// generated by Fast Light User Interface Designer (fluid) version 1.0104

#include "redgl.h"
#include <FL/Fl.H>
#include<FL/Fl_File_Chooser.H>
#include<FL/fl_draw.H>
#include<FL/gl.h>
#include <GL/glu.h>
#include <math.h>
#include"image.h"
static int dirty;
static char currentlevel[256];
static Segment segment[256];
static int activeSegment;

Fl_Double_Window* make_box() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = new Fl_Double_Window(104, 100);
    w = o;
    new Fl_Box(25, 25, 25, 25, "label");
    o->end();
  }
  return w;
}
static Fl_Perspective_Preview *perspectivePreview;

Fl_Palette_Map::Fl_Palette_Map(int x,int y,int w,int h,const char *s) : Fl_Box(x,y,w,h,s) {
}

void Fl_Palette_Map::draw() {
  int x=this->x();
int y=this->y();
int w=this->w();
int h=this->h();
if(w<1 || h<1) return;

uchar *buf=new uchar[w*h*3];
int i,j,pos=0;

for(j=0;j<h;j++) {
	for(i=0;i<w;i++) {
		pos=(i+j*w)*3;
		int p=i*256/w;
		if(p<0) p=0;
		if(p>255) p=255;
		unsigned int c=segment[activeSegment].palette[p];
		buf[pos+2]=(unsigned char)(c>>16);
		buf[pos+1]=(unsigned char)(c>>8);
		buf[pos]=(unsigned char)c;
	}
}

fl_push_clip(x,y,w,h);
fl_draw_image(buf,x,y,w,h);
fl_pop_clip();
delete []buf;
}
Trigger trigger[256];
int activeTrigger;
int activeStage;

Fl_StageXY::Fl_StageXY(int x,int y,int w,int h,const char *title):Fl_Box(x,y,w,h,title) {
}

void Fl_StageXY::draw() {
  const int grid=256;
int i;
float scale=1.0f;
float xoff=w()/2+x();
float yoff=h()/2+y();
fl_push_clip(x(),y(),w(),h());
fl_color(96,96,96);
fl_rectf(x(),y(),w(),h());
fl_color(255,255,255);

fl_loop((int)xoff-5,(int)yoff+5+35,(int)xoff+5,(int)yoff+5+35,(int)xoff,(int)yoff-5+35);

int row=(int)mapPosition->value()*grid;
fl_color(0,128,128);
Image *image=0;
//if(perspectivePreview) image=perspectivePreview->image;
if(image) for(i=0;i<grid-1;i++) {
	float vx[2],vy[2];
	if(row<0) row=0;
	if(row>=grid-1) row=grid-2;

	int terrainZ=image->data[row*image->textureWidth+i]&0xff;
	vx[0]=(i-grid/2)*segment[activeSegment].length;
	vy[0]=((int)terrainZ-255)*(1/255.0f)*segment[activeSegment].scale-155;
	terrainZ=image->data[row*image->textureWidth+i+1]&0xff;
	vx[1]=(i-grid/2)*segment[activeSegment].length;
	vy[1]=((int)terrainZ-255)*(1/255.0f)*segment[activeSegment].scale-155;

	if(segment[activeSegment].isTunnel) {
		// Transform x and y into a circle.
		float angle=(i+grid/4)/(float)(grid-2)*3.1415926535f*2;
		float y=vy[0];
		vx[0]=cosf(angle)*(-y);
		vy[0]=sinf(angle)*(-y);
		angle=(i+1+grid/4)/(float)(grid-2)*3.1415926535f*2;
		y=vy[0];
		vx[1]=cosf(angle)*(-y);
		vy[1]=sinf(angle)*(-y);
	}
	vx[0]=(int)(vx[0]*scale)+xoff;
	vx[1]=(int)(vx[1]*scale)+xoff;
	vy[0]=(int)(-vy[0]*scale)+yoff;
	vy[1]=(int)(-vy[1]*scale)+yoff;
	fl_line((int)vx[0],(int)vy[0],(int)vx[1],(int)vy[1]);
}

fl_color(0,0,0);
for(i=0;i<trigger[activeTrigger].stageCount-1;i++) {
	float x[2],y[2];
	x[0]=trigger[activeTrigger].stage[i].pos[0]*scale+xoff;
	x[1]=trigger[activeTrigger].stage[i+1].pos[0]*scale+xoff;
	y[0]=-trigger[activeTrigger].stage[i].pos[1]*scale+yoff;
	y[1]=-trigger[activeTrigger].stage[i+1].pos[1]*scale+yoff;
	fl_line((int)x[0],(int)y[0],(int)x[1],(int)y[1]);
}
fl_color(0,0,128);
for(i=0;i<trigger[activeTrigger].stageCount;i++) {
	float x,y;
	x=trigger[activeTrigger].stage[i].pos[0]*scale+xoff;
	y=-trigger[activeTrigger].stage[i].pos[1]*scale+yoff;
	fl_rect((int)x-1,(int)y-1,3,3);
}
fl_color(255,0,0);
{
	float x,y;
	x=trigger[activeTrigger].stage[activeStage].pos[0]*scale+xoff;
	y=-trigger[activeTrigger].stage[activeStage].pos[1]*scale+yoff;
	fl_rectf((int)x-1,(int)y-1,3,3);
}

fl_pop_clip();
}

int Fl_StageXY::handle(int event) {
  float x=(Fl::event_x()-this->x()-w()/2)*1.0f;
float y=-(Fl::event_y()-this->y()-h()/2)*1.0f;

switch(event) {
case FL_PUSH:
	save_undo(UR_CHANGE);
case FL_DRAG:
	trigger[activeTrigger].stage[activeStage].pos[0]=x;
	triggerX->value(x);
	trigger[activeTrigger].stage[activeStage].pos[1]=y;
	triggerY->value(y);
	stageXY->redraw();
	stageXZTrigger->redraw();
	stageYZTrigger->redraw();
	perspectivePreview->redraw();
	break;
default:
	return 0;
}
return 1;
}

Fl_StageZTrigger::Fl_StageZTrigger(int x,int y,int w,int h,const char *title):Fl_Box(x,y,w,h,title) {
  showY=true;
base=0.0f;
scale=1.0f;
}

void Fl_StageZTrigger::draw() {
  int i;
float scalet=w();
scalet*=scale;
float toff=x()-base*scalet;
float scaley=-0.5f;
int seg=trigger[activeTrigger].segment;
float scalex=(float)w()/(segment[seg].length*256)*scale;
float xoff=x()-base*scalet;
float yoff=h()/2+y();
fl_push_clip(x(),y(),w(),h());
fl_color(96,96,96);
fl_rectf(x(),y(),w(),h());
fl_color(255,255,255);
float t=toff+scalet*trigger[activeTrigger].stage[activeStage].trigger;
if(!showY)
	fl_loop((int)t-5,(int)yoff+5,(int)t+5,(int)yoff+5,(int)t,(int)yoff-5);
else
	fl_loop((int)t-5,(int)yoff+5-(int)(35*scaley),(int)t+5,(int)yoff+5-(int)(35*scaley),(int)t,(int)yoff-5-(int)(35*scaley));
for(i=0;i<trigger[activeTrigger].stageCount;i++) {
	float x=toff+trigger[activeTrigger].stage[i].trigger*scalet;
	if(i==activeStage)
		fl_color(255,0,64);
	else
		fl_color(192,0,0);
	fl_line((int)x,y(),(int)x,y()+h());
}
fl_color(0,0,0);
for(i=0;i<trigger[activeTrigger].stageCount-1;i++) {
	float x[2],y[2];
	x[0]=trigger[activeTrigger].stage[i].pos[2]*scalex+xoff;
	x[1]=trigger[activeTrigger].stage[i+1].pos[2]*scalex+xoff;
	y[0]=trigger[activeTrigger].stage[i].pos[showY?1:0]*scaley+yoff;
	y[1]=trigger[activeTrigger].stage[i+1].pos[showY?1:0]*scaley+yoff;
	fl_line((int)x[0],(int)y[0],(int)x[1],(int)y[1]);
}
fl_color(0,0,192);
for(i=0;i<trigger[activeTrigger].stageCount;i++) {
	float x,y;
	x=trigger[activeTrigger].stage[i].pos[2]*scalex+xoff;
	y=trigger[activeTrigger].stage[i].pos[showY?1:0]*scaley+yoff;
	fl_rect((int)x-1,(int)y-1,3,3);
}
fl_color(255,0,0);
{
	float x,y;
	x=trigger[activeTrigger].stage[activeStage].pos[2]*scalex+xoff;
	y=trigger[activeTrigger].stage[activeStage].pos[showY?1:0]*scaley+yoff;
	fl_rectf((int)x-1,(int)y-1,3,3);
}

fl_pop_clip();
}

int Fl_StageZTrigger::handle(int event) {
  if(showY) {
	valueYZTriggerBase->value(base);
	valueYZTriggerScale->value(scale);
} else {
	valueXZTriggerBase->value(base);
	valueXZTriggerScale->value(scale);
}
float t=(Fl::event_x()-this->x())/(float)w();
t=t/scale+base;
int seg=trigger[activeTrigger].segment;
float scalez=(segment[seg].length*256);
float z=t*scalez;
float y=-(Fl::event_y()-this->y()-h()/2)*2.0f;
float dz,dy;

switch(event) {
case FL_PUSH:
	save_undo(UR_CHANGE);
	dz=z-trigger[activeTrigger].stage[activeStage].pos[2];
	dy=y-trigger[activeTrigger].stage[activeStage].pos[showY?1:0];
	dz=dz<0?-dz:dz;
	dy=dy<0?-dy:dy;
	if(dz<10*scalez/(float)w()/scale && dy<20) editZ=true;
	else editZ=false;
	printf("editZ=%d\n",(int)editZ);
	// fall through
case FL_DRAG:
	if(editZ==false) {
		trigger[activeTrigger].stage[activeStage].trigger=t;
		triggerTrigger->value(t);
	} else {
		trigger[activeTrigger].stage[activeStage].pos[2]=z;
		triggerZ->value(z);
		trigger[activeTrigger].stage[activeStage].pos[showY?1:0]=y;
		if(showY) triggerY->value(y);
		else triggerX->value(y);
	}
	stageXY->redraw();
	stageYZTrigger->redraw();
	stageXZTrigger->redraw();
	perspectivePreview->redraw();
	break;
default:
	return 0;
}
return 1;
}

void Fl_StageZTrigger::setView(bool showYZTrigger) {
  showY=showYZTrigger;
redraw();
}
static EnemyModel enemyModel[64];
static int activeEnemy;

Fl_Double_Window *rootWindow=(Fl_Double_Window *)0;

static void cb_New(Fl_Menu_*, void*) {
  new_level();
}

static void cb_Open(Fl_Menu_*, void*) {
  open_level();
}

static void cb_Save(Fl_Menu_*, void*) {
  save_level();
}

static void cb_Save1(Fl_Menu_*, void*) {
  saveas_level();
}

static void cb_Quit(Fl_Menu_*, void*) {
  quit_editor();
}

static void cb_undoMenuItem(Fl_Menu_*, void*) {
  undo();
}

static void cb_About(Fl_Menu_*, void*) {
  make_about()->show();
}

Fl_Menu_Item menu_[] = {
 {"&File", 0,  0, 0, 64, 0, 0, 14, 56},
 {"&New", 0x4006e,  (Fl_Callback*)cb_New, 0, 0, 0, 0, 14, 56},
 {"&Open", 0,  (Fl_Callback*)cb_Open, 0, 0, 0, 0, 14, 56},
 {"&Save", 0x40073,  (Fl_Callback*)cb_Save, 0, 0, 0, 0, 14, 56},
 {"&Save As...", 0x40061,  (Fl_Callback*)cb_Save1, 0, 0, 0, 0, 14, 56},
 {"&Quit", 0,  (Fl_Callback*)cb_Quit, 0, 0, 0, 0, 14, 56},
 {0},
 {"Targets", 0,  0, 0, 64, 0, 0, 14, 56},
 {"Undo", 0x4007a,  (Fl_Callback*)cb_undoMenuItem, 0, 0, 0, 0, 14, 56},
 {0},
 {"&Help", 0,  0, 0, 64, 0, 0, 14, 56},
 {"&About", 0xffc9,  (Fl_Callback*)cb_About, 0, 0, 0, 0, 14, 56},
 {0},
 {0}
};

Fl_Counter *levelDuration=(Fl_Counter *)0;

Fl_Counter *levelSegments=(Fl_Counter *)0;

static void cb_levelSegments(Fl_Counter* o, void*) {
  int seg=(int)o->value();
pathPosition->maximum(seg-1);
pathPosition->slider_size(1.0/seg);
}

Fl_Value_Input *evoDropRate=(Fl_Value_Input *)0;

Fl_Value_Input *chaosDropRate=(Fl_Value_Input *)0;

Fl_Value_Input *initialEvo=(Fl_Value_Input *)0;

Fl_Value_Input *initialChaos=(Fl_Value_Input *)0;

Fl_Counter *bpm=(Fl_Counter *)0;

Fl_Input *song=(Fl_Input *)0;

Fl_Value_Slider *pathPosition=(Fl_Value_Slider *)0;

static void cb_pathPosition(Fl_Value_Slider* o, void*) {
  activeSegment=(int)o->value();
//printf("Active segment: %d\n",activeSegment);
show_segment();
}

Fl_Check_Button *isTunnel=(Fl_Check_Button *)0;

static void cb_isTunnel(Fl_Check_Button* o, void*) {
  segment[activeSegment].isTunnel=o->value();
perspectivePreview->redraw();
}

Fl_Round_Button *buttonFront=(Fl_Round_Button *)0;

static void cb_buttonFront(Fl_Round_Button* o, void*) {
  if(o->value()) segment[activeSegment].cameraAngle=0;
perspectivePreview->redraw();
}

Fl_Round_Button *buttonLeft=(Fl_Round_Button *)0;

static void cb_buttonLeft(Fl_Round_Button* o, void*) {
  if(o->value()) segment[activeSegment].cameraAngle=1;
perspectivePreview->redraw();
}

Fl_Round_Button *buttonRight=(Fl_Round_Button *)0;

static void cb_buttonRight(Fl_Round_Button* o, void*) {
  if(o->value()) segment[activeSegment].cameraAngle=2;
perspectivePreview->redraw();
}

Fl_Round_Button *visWallp=(Fl_Round_Button *)0;

static void cb_visWallp(Fl_Round_Button*, void*) {
  segment[activeSegment].visualization=0;
new_map();
}

Fl_Round_Button *visJulia=(Fl_Round_Button *)0;

static void cb_visJulia(Fl_Round_Button*, void*) {
  segment[activeSegment].visualization=2;
new_map();
}

Fl_Round_Button *visPlasma=(Fl_Round_Button *)0;

static void cb_visPlasma(Fl_Round_Button*, void*) {
  segment[activeSegment].visualization=1;
new_map();
}

Fl_Round_Button *visWallp2=(Fl_Round_Button *)0;

static void cb_visWallp2(Fl_Round_Button*, void*) {
  segment[activeSegment].visualization=3;
new_map();
}

Fl_Round_Button *visCustom=(Fl_Round_Button *)0;

static void cb_visCustom(Fl_Round_Button*, void*) {
  segment[activeSegment].visualization=4;
new_map();
}

static void cb_(Fl_Button*, void*) {
  char fname[256];
strcpy(fname,currentlevel);
char *s=fname;
if(strrchr(fname,'.')) s=strrchr(fname,'.');
sprintf(s,"seg%dheight.png",activeSegment);

char *imagename=fl_file_chooser("Open Height Map File","*.png",0);
if(imagename) {
	file_copy(imagename,fname);
	Image *image=loadPng(fname);
	if(image && image->textureWidth==256 && image->textureHeight==256) {
		freeImage(image);
	} else if(image) {
		char buf[512];
		sprintf(buf,"Image must be 256x256 not %dx%d\n",image->imageWidth,image->imageHeight);
		fl_alert(buf);
		freeImage(image);
	} else {
		fl_alert("Unable to load image.  Is it a valad PNG?");
	}
	new_map();
};
}

static void cb_CMap(Fl_Button*, void*) {
  char fname[256];
strcpy(fname,currentlevel);
char *s=fname;
if(strrchr(fname,'.')) s=strrchr(fname,'.');
sprintf(s,"seg%dcolor.png",activeSegment);

char *imagename=fl_file_chooser("Open Color Map File","*.png",0);
if(imagename) {
	file_copy(imagename,fname);
	Image *image=loadPng(fname);
	if(image && image->textureWidth==256 && image->textureHeight==256) {
		freeImage(image);
	} else if(image) {
		char buf[512];
		sprintf(buf,"Image must be 256x256 not %dx%d\n",image->imageWidth,image->imageHeight);
		fl_alert(buf);
		freeImage(image);
	} else {
		fl_alert("Unable to load image.  Is it a valad PNG?");
	}
	new_map();
};
}

Fl_Value_Input *seedA=(Fl_Value_Input *)0;

static void cb_seedA(Fl_Value_Input* o, void*) {
  segment[activeSegment].seed[0]=o->value();
new_map();
}

Fl_Value_Input *seedB=(Fl_Value_Input *)0;

static void cb_seedB(Fl_Value_Input* o, void*) {
  segment[activeSegment].seed[1]=o->value();
new_map();
}

Fl_Value_Slider *segHeight=(Fl_Value_Slider *)0;

static void cb_segHeight(Fl_Value_Slider*, void*) {
  segment[activeSegment].scale=segHeight->value();
perspectivePreview->redraw();
}

Fl_Value_Slider *segLength=(Fl_Value_Slider *)0;

static void cb_segLength(Fl_Value_Slider*, void*) {
  segment[activeSegment].length=segLength->value();
perspectivePreview->redraw();
}

Fl_Counter *fogNear=(Fl_Counter *)0;

static void cb_fogNear(Fl_Counter*, void*) {
  segment[activeSegment].fogNear=fogNear->value();
perspectivePreview->redraw();
}

Fl_Counter *fogFar=(Fl_Counter *)0;

static void cb_fogFar(Fl_Counter* o, void*) {
  segment[activeSegment].fogFar=o->value();
perspectivePreview->redraw();
}

Fl_Input *fogColor=(Fl_Input *)0;

static void cb_fogColor(Fl_Input* o, void*) {
  unsigned int color;
sscanf(o->value(),"#%x",&color);
segment[activeSegment].fogColor=color|0xff000000;
perspectivePreview->redraw();
}

static void cb_Load(Fl_Button*, void*) {
  load_palette();
palettePreview->redraw();
new_map();
}

Fl_Palette_Map *palettePreview=(Fl_Palette_Map *)0;

Fl_Box *mapPreview=(Fl_Box *)0;

static void cb_1(Fl_Roller* o, void*) {
  hue_palette(o->value());
palettePreview->redraw();
genTerrain();
new_map();
}

Fl_Value_Slider *mapPosition=(Fl_Value_Slider *)0;

static void cb_mapPosition(Fl_Value_Slider*, void*) {
  perspectivePreview->redraw();
}

Fl_Browser *triggerList=(Fl_Browser *)0;

static void cb_triggerList(Fl_Browser* o, void*) {
  save_undo(UR_SELECTION);
activeTrigger=o->value();
update_trigger();
}

static void cb_Add(Fl_Button*, void*) {
  save_undo(UR_ADD);
char buf[256];
sprintf(buf,"target%d",triggerList->size()+1);
triggerList->insert(triggerList->size()+1,buf);
}

static void cb_Clone(Fl_Button*, void*) {
  save_undo(UR_ADD);
int i=triggerList->size()+1;
triggerList->add("Clone");
strcpy(trigger[i].type,trigger[activeTrigger].type);
trigger[i].segment=trigger[activeTrigger].segment;
trigger[i].health=trigger[activeTrigger].health;
trigger[i].points=trigger[activeTrigger].points;
trigger[i].bonusType=trigger[activeTrigger].bonusType;
trigger[i].stageCount=trigger[activeTrigger].stageCount;
int j;
for(j=0;j<trigger[activeTrigger].stageCount;j++) {
	trigger[i].stage[j].trigger=trigger[activeTrigger].stage[j].trigger;
	trigger[i].stage[j].pos[0]=trigger[activeTrigger].stage[j].pos[0];
	trigger[i].stage[j].pos[1]=trigger[activeTrigger].stage[j].pos[1];
	trigger[i].stage[j].pos[2]=trigger[activeTrigger].stage[j].pos[2];
	trigger[i].stage[j].orient[0]=trigger[activeTrigger].stage[j].orient[0];
	trigger[i].stage[j].orient[1]=trigger[activeTrigger].stage[j].orient[1];
	trigger[i].stage[j].orient[2]=trigger[activeTrigger].stage[j].orient[2];
};
}

static void cb_x(Fl_Button*, void*) {
  save_undo(UR_CHANGE);
int j;
for(j=0;j<trigger[activeTrigger].stageCount;j++) {
	trigger[activeTrigger].stage[j].pos[0]=-trigger[activeTrigger].stage[j].pos[0];
	trigger[activeTrigger].stage[j].orient[0]=-trigger[activeTrigger].stage[j].orient[0];
}
update_stage();
}

Fl_Choice *triggerScore=(Fl_Choice *)0;

static void cb_triggerScore(Fl_Choice* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].points=o->value();
}

Fl_Menu_Item menu_triggerScore[] = {
 {"100", 0,  0, 0, 0, 0, 0, 14, 56},
 {"250", 0,  0, 0, 0, 0, 0, 14, 56},
 {"1000", 0,  0, 0, 0, 0, 0, 14, 56},
 {0}
};

Fl_Choice *triggerBonus=(Fl_Choice *)0;

static void cb_triggerBonus(Fl_Choice* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].bonusType=o->value();
}

Fl_Menu_Item menu_triggerBonus[] = {
 {"No Bonus", 0,  0, 0, 0, 0, 0, 14, 56},
 {"Evolution Up", 0,  0, 0, 0, 0, 0, 14, 56},
 {"Chaos Up", 0,  0, 0, 0, 0, 0, 14, 56},
 {"Next Level", 0,  0, 0, 0, 0, 0, 14, 56},
 {0}
};

Fl_Input *triggerName=(Fl_Input *)0;

Fl_Choice *triggerType=(Fl_Choice *)0;

static void cb_triggerType(Fl_Choice* o, void*) {
  save_undo(UR_CHANGE);
const char *s=o->text();
strcpy(trigger[activeTrigger].type,s);
}

Fl_Menu_Item menu_triggerType[] = {
 {"", 0,  0, 0, 0, 0, 0, 14, 56},
 {0}
};

static void cb_Add1(Fl_Button*, void*) {
  char *fname=fl_file_chooser("Open MD2 Model","*.md2",0);
if(fname) {
	char *s=strrchr(fname,'\\');
	if(s) {
		s++;
	} else {
		s=strrchr(fname,'/');
		if(s) s++;
		else s=fname;
	}
	triggerType->add(s,0,0,0,0);
	int i;
	for(i=0;i<=enemyList->size();i++) {
		if(strcmp(s,enemyModel[i].name)==0) break;
	}
	if(i==enemyList->size()+1) {
		strcpy(enemyModel[i].name,s);
		enemyList->add(s);
	}
};
}

Fl_Value_Slider *triggerSegment=(Fl_Value_Slider *)0;

static void cb_triggerSegment(Fl_Value_Slider* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].segment=(int)o->value();
activeSegment=(int)o->value();
pathPosition->value(activeSegment);
show_segment();
}

Fl_Value_Input *triggerHitPoints=(Fl_Value_Input *)0;

static void cb_triggerHitPoints(Fl_Value_Input* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].health=(int)o->value();
}

Fl_Value_Slider *triggerStage=(Fl_Value_Slider *)0;

static void cb_triggerStage(Fl_Value_Slider* o, void*) {
  save_undo(UR_SELECTION);
activeStage=(int)o->value();
update_stage();
}

Fl_Value_Slider *triggerStageCount=(Fl_Value_Slider *)0;

static void cb_triggerStageCount(Fl_Value_Slider* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].stageCount=(int)o->value();
triggerStage->maximum(trigger[activeTrigger].stageCount-1.0f);
triggerStage->slider_size(1.0f/trigger[activeTrigger].stageCount);
update_stage();
}

Fl_Value_Input *triggerX=(Fl_Value_Input *)0;

static void cb_triggerX(Fl_Value_Input* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].stage[activeStage].pos[0]=o->value();
stageXY->redraw();
stageXZTrigger->redraw();
stageYZTrigger->redraw();
perspectivePreview->redraw();
}

Fl_Value_Input *triggerY=(Fl_Value_Input *)0;

static void cb_triggerY(Fl_Value_Input* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].stage[activeStage].pos[1]=o->value();
stageXY->redraw();
stageXZTrigger->redraw();
stageYZTrigger->redraw();
perspectivePreview->redraw();
}

Fl_Value_Input *triggerZ=(Fl_Value_Input *)0;

static void cb_triggerZ(Fl_Value_Input* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].stage[activeStage].pos[2]=o->value();
stageXY->redraw();
stageXZTrigger->redraw();
stageYZTrigger->redraw();
perspectivePreview->redraw();
}

Fl_Value_Input *triggerRX=(Fl_Value_Input *)0;

static void cb_triggerRX(Fl_Value_Input* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].stage[activeStage].orient[0]=o->value();
}

Fl_Value_Input *triggerRY=(Fl_Value_Input *)0;

static void cb_triggerRY(Fl_Value_Input* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].stage[activeStage].orient[1]=o->value();
}

Fl_Value_Input *triggerRZ=(Fl_Value_Input *)0;

static void cb_triggerRZ(Fl_Value_Input* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].stage[activeStage].orient[2]=o->value();
}

Fl_Value_Input *triggerTrigger=(Fl_Value_Input *)0;

static void cb_triggerTrigger(Fl_Value_Input* o, void*) {
  save_undo(UR_CHANGE);
trigger[activeTrigger].stage[activeStage].trigger=o->value();
stageXZTrigger->redraw();
stageYZTrigger->redraw();
perspectivePreview->redraw();
}

Fl_Roller *triggerRoller=(Fl_Roller *)0;

static void cb_triggerRoller(Fl_Roller* o, void*) {
  save_undo(UR_CHANGE);
triggerTrigger->value(o->value());
trigger[activeTrigger].stage[activeStage].trigger=o->value();
stageXZTrigger->redraw();
stageYZTrigger->redraw();
}

Fl_StageXY *stageXY=(Fl_StageXY *)0;

Fl_StageZTrigger *stageYZTrigger=(Fl_StageZTrigger *)0;

static void cb_y(Fl_Button*, void*) {
  save_undo(UR_CHANGE);
int j;
for(j=0;j<trigger[activeTrigger].stageCount;j++) {
	trigger[activeTrigger].stage[j].pos[1]=-trigger[activeTrigger].stage[j].pos[1];
	trigger[activeTrigger].stage[j].orient[1]=-trigger[activeTrigger].stage[j].orient[1];
}
update_stage();
}

static void cb_Delete(Fl_Button*, void*) {
  save_undo(UR_DELETE);
int size=triggerList->size();
int i;
for(i=activeTrigger;i<size;i++) {
	char buf[256];
	trigger[i]=trigger[i+1];
	sprintf(buf,"seg%dtgt%d",trigger[i].segment,i);
	triggerList->replace(i,buf);
}
triggerList->remove(triggerList->size());
if(triggerList->size()<activeTrigger) activeTrigger=1;
update_trigger();
}

Fl_StageZTrigger *stageXZTrigger=(Fl_StageZTrigger *)0;

static void cb_2(Fl_Button*, void*) {
  stageYZTrigger->scale*=1.1f;
update_scale(stageYZTrigger,scrollYZTrigger);
}

static void cb_3(Fl_Button*, void*) {
  stageYZTrigger->scale/=1.1f;
update_scale(stageYZTrigger,scrollYZTrigger);
}

static void cb_Orig(Fl_Button*, void*) {
  stageYZTrigger->scale=1.0f;
update_scale(stageYZTrigger,scrollYZTrigger);
}

static void cb_4(Fl_Button*, void*) {
  stageXZTrigger->scale*=1.1f;
update_scale(stageXZTrigger,scrollXZTrigger);
}

static void cb_5(Fl_Button*, void*) {
  stageXZTrigger->scale/=1.1f;
update_scale(stageXZTrigger,scrollXZTrigger);
}

static void cb_Orig1(Fl_Button*, void*) {
  stageXZTrigger->scale=1.0f;
update_scale(stageXZTrigger,scrollXZTrigger);
}

Fl_Slider *scrollYZTrigger=(Fl_Slider *)0;

static void cb_scrollYZTrigger(Fl_Slider* o, void*) {
  stageYZTrigger->base=o->value();
stageYZTrigger->redraw();
valueYZTriggerBase->value(o->value());
}

Fl_Slider *scrollXZTrigger=(Fl_Slider *)0;

static void cb_scrollXZTrigger(Fl_Slider* o, void*) {
  stageXZTrigger->base=o->value();
stageXZTrigger->redraw();
valueXZTriggerBase->value(o->value());
}

Fl_Value_Output *valueYZTriggerBase=(Fl_Value_Output *)0;

Fl_Value_Output *valueYZTriggerScale=(Fl_Value_Output *)0;

Fl_Value_Output *valueXZTriggerBase=(Fl_Value_Output *)0;

Fl_Value_Output *valueXZTriggerScale=(Fl_Value_Output *)0;

static void cb_Step(Fl_Button*, void*) {
  make_stepandrepeat()->show();
}

Fl_Browser *enemyList=(Fl_Browser *)0;

static void cb_enemyList(Fl_Browser* o, void*) {
  activeEnemy=o->value();
update_enemy();
}

Fl_Input *explosionFirstColor=(Fl_Input *)0;

static void cb_explosionFirstColor(Fl_Input* o, void*) {
  unsigned int color;
sscanf(o->value(),"#%x",&color);
enemyModel[activeEnemy].explosionFirstColor=color|0xff000000;
}

Fl_Input *explosionLastColor=(Fl_Input *)0;

static void cb_explosionLastColor(Fl_Input* o, void*) {
  unsigned int color;
sscanf(o->value(),"#%x",&color);
enemyModel[activeEnemy].explosionLastColor=color|0xff000000;
}

Fl_Value_Input *explosionRadius=(Fl_Value_Input *)0;

static void cb_explosionRadius(Fl_Value_Input* o, void*) {
  enemyModel[activeEnemy].explosionRadius=o->value();
}

Fl_Value_Input *explosionHeight=(Fl_Value_Input *)0;

static void cb_explosionHeight(Fl_Value_Input* o, void*) {
  enemyModel[activeEnemy].explosionHeightScale=o->value();
}

Fl_Input *soundLockOn=(Fl_Input *)0;

static void cb_soundLockOn(Fl_Input* o, void*) {
  strcpy(enemyModel[activeEnemy].lockOnSound,o->value());
}

static void cb_6(Fl_Button*, void*) {
  char *fname=fl_file_chooser("Open WAV Sound","*.wav",0);
if(fname) {
	char *s=strrchr(fname,'\\');
	if(s) {
		s++;
	} else {
		s=strrchr(fname,'/');
		if(s) s++;
		else s=fname;
	}
	soundLockOn->value(s);
	strcpy(enemyModel[activeEnemy].lockOnSound,s);
};
}

Fl_Input *soundExplode=(Fl_Input *)0;

static void cb_soundExplode(Fl_Input* o, void*) {
  strcpy(enemyModel[activeEnemy].explodeSound,o->value());
}

static void cb_7(Fl_Button*, void*) {
  char *fname=fl_file_chooser("Open WAV Sound","*.wav",0);
if(fname) {
	char *s=strrchr(fname,'\\');
	if(s) {
		s++;
	} else {
		s=strrchr(fname,'/');
		if(s) s++;
		else s=fname;
	}
	soundExplode->value(s);
	strcpy(enemyModel[activeEnemy].explodeSound,s);
};
}

Fl_Value_Input *explosionDuration=(Fl_Value_Input *)0;

static void cb_explosionDuration(Fl_Value_Input* o, void*) {
  enemyModel[activeEnemy].explosionDuration=o->value();
}

int main(int argc, char **argv) {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = rootWindow = new Fl_Double_Window(935, 715, "Resonate Level Segment Editor");
    w = o;
    { Fl_Menu_Bar* o = new Fl_Menu_Bar(0, 0, 940, 25);
      o->menu(menu_);
    }
    { Fl_Tabs* o = new Fl_Tabs(5, 30, 925, 680);
      { Fl_Group* o = new Fl_Group(15, 65, 880, 595, "Segments");
        { Fl_Group* o = new Fl_Group(25, 85, 870, 140, "Global Level Settings");
          o->box(FL_DOWN_FRAME);
          o->align(FL_ALIGN_TOP_LEFT);
          { Fl_Counter* o = levelDuration = new Fl_Counter(205, 90, 145, 25, "Level Duration (in min)");
            o->minimum(1);
            o->maximum(1024);
            o->step(0.1);
            o->align(FL_ALIGN_LEFT);
          }
          { Fl_Counter* o = levelSegments = new Fl_Counter(545, 90, 135, 25, "Level Segments");
            o->minimum(4);
            o->maximum(256);
            o->step(1);
            o->value(8);
            o->callback((Fl_Callback*)cb_levelSegments);
            o->align(FL_ALIGN_LEFT);
          }
          evoDropRate = new Fl_Value_Input(190, 125, 80, 25, "Automatic Evolution Up");
          chaosDropRate = new Fl_Value_Input(190, 155, 80, 25, "Automatic Chaos Up");
          initialEvo = new Fl_Value_Input(380, 125, 80, 25, "Initial Evolution");
          initialChaos = new Fl_Value_Input(380, 155, 80, 25, "Initital Chaos");
          { Fl_Counter* o = bpm = new Fl_Counter(190, 185, 145, 30, "Beats per Minute");
            o->minimum(1);
            o->maximum(1024);
            o->step(0.1);
            o->align(FL_ALIGN_LEFT);
          }
          song = new Fl_Input(525, 125, 295, 25, "Song");
          new Fl_Button(820, 125, 30, 25, "...");
          o->end();
        }
        { Fl_Value_Slider* o = pathPosition = new Fl_Value_Slider(225, 625, 465, 20, "Segment Selector");
          o->type(1);
          o->maximum(16);
          o->step(1);
          o->slider_size(0.0625);
          o->callback((Fl_Callback*)cb_pathPosition);
          o->align(FL_ALIGN_LEFT);
        }
        { Fl_Group* o = new Fl_Group(25, 245, 870, 375, "Segment Settings");
          o->box(FL_DOWN_FRAME);
          o->align(FL_ALIGN_TOP_LEFT);
          { Fl_Check_Button* o = isTunnel = new Fl_Check_Button(45, 260, 185, 25, "Tunnel, not Landscape");
            o->down_box(FL_DOWN_BOX);
            o->callback((Fl_Callback*)cb_isTunnel);
          }
          { Fl_Group* o = new Fl_Group(40, 300, 180, 35, "Camera View");
            o->box(FL_DOWN_FRAME);
            { Fl_Round_Button* o = buttonFront = new Fl_Round_Button(95, 310, 55, 25, "Front");
              o->type(102);
              o->down_box(FL_ROUND_DOWN_BOX);
              o->callback((Fl_Callback*)cb_buttonFront);
            }
            { Fl_Round_Button* o = buttonLeft = new Fl_Round_Button(45, 310, 45, 25, "Left");
              o->type(102);
              o->down_box(FL_ROUND_DOWN_BOX);
              o->callback((Fl_Callback*)cb_buttonLeft);
            }
            { Fl_Round_Button* o = buttonRight = new Fl_Round_Button(155, 310, 55, 25, "Right");
              o->type(102);
              o->down_box(FL_ROUND_DOWN_BOX);
              o->callback((Fl_Callback*)cb_buttonRight);
            }
            o->end();
          }
          { Fl_Group* o = new Fl_Group(40, 420, 180, 140, "Visualization");
            o->box(FL_DOWN_FRAME);
            { Fl_Round_Button* o = visWallp = new Fl_Round_Button(45, 425, 170, 25, "Wallpaper for the mind");
              o->type(102);
              o->down_box(FL_ROUND_DOWN_BOX);
              o->callback((Fl_Callback*)cb_visWallp);
            }
            { Fl_Round_Button* o = visJulia = new Fl_Round_Button(45, 450, 165, 25, "Julia Set");
              o->type(102);
              o->down_box(FL_ROUND_DOWN_BOX);
              o->callback((Fl_Callback*)cb_visJulia);
            }
            { Fl_Round_Button* o = visPlasma = new Fl_Round_Button(45, 475, 165, 25, "Plasma");
              o->type(102);
              o->down_box(FL_ROUND_DOWN_BOX);
              o->callback((Fl_Callback*)cb_visPlasma);
            }
            { Fl_Round_Button* o = visWallp2 = new Fl_Round_Button(45, 500, 165, 25, "Wallpaper squared");
              o->type(102);
              o->down_box(FL_ROUND_DOWN_BOX);
              o->callback((Fl_Callback*)cb_visWallp2);
            }
            { Fl_Round_Button* o = visCustom = new Fl_Round_Button(45, 525, 105, 25, "Custom PNG");
              o->type(102);
              o->down_box(FL_ROUND_DOWN_BOX);
              o->callback((Fl_Callback*)cb_visCustom);
            }
            { Fl_Button* o = new Fl_Button(150, 525, 25, 25, "...");
              o->callback((Fl_Callback*)cb_);
            }
            { Fl_Button* o = new Fl_Button(175, 525, 40, 25, "CMap");
              o->callback((Fl_Callback*)cb_CMap);
            }
            o->end();
          }
          { Fl_Value_Input* o = seedA = new Fl_Value_Input(125, 345, 95, 25, "Seed A");
            o->minimum(-5);
            o->maximum(5);
            o->step(0.001);
            o->callback((Fl_Callback*)cb_seedA);
          }
          { Fl_Value_Input* o = seedB = new Fl_Value_Input(125, 375, 95, 25, "Seed B");
            o->minimum(-5);
            o->maximum(5);
            o->step(0.001);
            o->callback((Fl_Callback*)cb_seedB);
          }
          { Fl_Value_Slider* o = segHeight = new Fl_Value_Slider(230, 265, 60, 285, "Height");
            o->type(4);
            o->minimum(1);
            o->maximum(256);
            o->step(0.1);
            o->value(16);
            o->callback((Fl_Callback*)cb_segHeight);
          }
          { Fl_Value_Slider* o = segLength = new Fl_Value_Slider(40, 570, 440, 40, "Length");
            o->type(5);
            o->minimum(1);
            o->maximum(256);
            o->step(0.1);
            o->value(16);
            o->callback((Fl_Callback*)cb_segLength);
          }
          { Fl_Group* o = new Fl_Group(295, 264, 180, 156, "Fog");
            o->box(FL_DOWN_FRAME);
            { Fl_Counter* o = fogNear = new Fl_Counter(310, 275, 155, 25, "Fog Near");
              o->step(0.1);
              o->callback((Fl_Callback*)cb_fogNear);
            }
            { Fl_Counter* o = fogFar = new Fl_Counter(310, 320, 155, 25, "Fog Far");
              o->step(0.1);
              o->callback((Fl_Callback*)cb_fogFar);
            }
            { Fl_Input* o = fogColor = new Fl_Input(310, 375, 155, 25, "Fog Color");
              o->callback((Fl_Callback*)cb_fogColor);
              o->align(FL_ALIGN_BOTTOM);
            }
            o->end();
          }
          { Fl_Button* o = new Fl_Button(295, 430, 105, 30, "Load Palette...");
            o->callback((Fl_Callback*)cb_Load);
          }
          { Fl_Palette_Map* o = palettePreview = new Fl_Palette_Map(295, 465, 180, 55, "Palette Preview");
            o->box(FL_DOWN_BOX);
            o->color(FL_BACKGROUND_COLOR);
            o->selection_color(FL_BACKGROUND_COLOR);
            o->labeltype(FL_NORMAL_LABEL);
            o->labelfont(0);
            o->labelsize(14);
            o->labelcolor(FL_BLACK);
            o->align(FL_ALIGN_BOTTOM);
            o->when(FL_WHEN_RELEASE);
          }
          { Fl_Box* o = mapPreview = new Fl_Box(515, 265, 330, 290, "Map Top View Preview");
            o->box(FL_DOWN_BOX);
          }
          { Fl_Roller* o = new Fl_Roller(405, 430, 65, 30);
            o->type(1);
            o->step(0.002);
            o->callback((Fl_Callback*)cb_1);
          }
          { Fl_Value_Slider* o = mapPosition = new Fl_Value_Slider(850, 265, 25, 290, "Pos");
            o->tooltip("Position on the perspective preview map");
            o->step(0.01);
            o->callback((Fl_Callback*)cb_mapPosition);
          }
          o->end();
        }
        o->end();
      }
      { Fl_Group* o = new Fl_Group(5, 65, 920, 645, "Targets");
        o->hide();
        { Fl_Browser* o = triggerList = new Fl_Browser(10, 130, 170, 295);
          o->type(2);
          o->callback((Fl_Callback*)cb_triggerList);
        }
        { Fl_Button* o = new Fl_Button(10, 75, 40, 25, "Add");
          o->callback((Fl_Callback*)cb_Add);
        }
        { Fl_Button* o = new Fl_Button(105, 75, 55, 25, "Clone");
          o->callback((Fl_Callback*)cb_Clone);
        }
        { Fl_Button* o = new Fl_Button(10, 100, 20, 25, "-x");
          o->callback((Fl_Callback*)cb_x);
        }
        { Fl_Group* o = new Fl_Group(190, 90, 340, 335, "Trigger Attributes");
          o->box(FL_DOWN_FRAME);
          o->align(FL_ALIGN_TOP_LEFT);
          { Fl_Choice* o = triggerScore = new Fl_Choice(255, 130, 130, 25, "Score");
            o->down_box(FL_BORDER_BOX);
            o->callback((Fl_Callback*)cb_triggerScore);
            o->menu(menu_triggerScore);
          }
          { Fl_Choice* o = triggerBonus = new Fl_Choice(255, 190, 130, 25, "Bonus");
            o->down_box(FL_BORDER_BOX);
            o->callback((Fl_Callback*)cb_triggerBonus);
            o->menu(menu_triggerBonus);
          }
          triggerName = new Fl_Input(255, 100, 265, 25, "Name");
          { Fl_Choice* o = triggerType = new Fl_Choice(255, 160, 130, 25, "Type");
            o->down_box(FL_BORDER_BOX);
            o->callback((Fl_Callback*)cb_triggerType);
            o->menu(menu_triggerType);
          }
          { Fl_Button* o = new Fl_Button(390, 160, 55, 25, "Add...");
            o->callback((Fl_Callback*)cb_Add1);
          }
          { Fl_Value_Slider* o = triggerSegment = new Fl_Value_Slider(255, 220, 265, 25, "Segment");
            o->type(1);
            o->maximum(7);
            o->step(1);
            o->callback((Fl_Callback*)cb_triggerSegment);
            o->align(FL_ALIGN_LEFT);
          }
          { Fl_Value_Input* o = triggerHitPoints = new Fl_Value_Input(460, 190, 60, 25, "Hit Points");
            o->minimum(1);
            o->maximum(8);
            o->value(1);
            o->callback((Fl_Callback*)cb_triggerHitPoints);
          }
          { Fl_Value_Slider* o = triggerStage = new Fl_Value_Slider(200, 265, 25, 135, "Stage");
            o->maximum(7);
            o->step(1);
            o->callback((Fl_Callback*)cb_triggerStage);
          }
          { Fl_Value_Slider* o = triggerStageCount = new Fl_Value_Slider(235, 265, 285, 20, "Stage Count");
            o->type(3);
            o->minimum(2);
            o->maximum(8);
            o->step(1);
            o->value(2);
            o->callback((Fl_Callback*)cb_triggerStageCount);
          }
          { Fl_Group* o = new Fl_Group(235, 315, 285, 100, "Stage Settings");
            o->box(FL_DOWN_FRAME);
            o->align(FL_ALIGN_TOP_LEFT);
            { Fl_Value_Input* o = triggerX = new Fl_Value_Input(260, 355, 65, 25, "x");
              o->minimum(-200);
              o->maximum(200);
              o->step(1);
              o->callback((Fl_Callback*)cb_triggerX);
            }
            { Fl_Value_Input* o = triggerY = new Fl_Value_Input(345, 355, 65, 25, "y");
              o->minimum(-200);
              o->maximum(200);
              o->step(1);
              o->callback((Fl_Callback*)cb_triggerY);
            }
            { Fl_Value_Input* o = triggerZ = new Fl_Value_Input(430, 355, 65, 25, "z");
              o->minimum(-8000);
              o->maximum(8000);
              o->step(1);
              o->callback((Fl_Callback*)cb_triggerZ);
            }
            { Fl_Value_Input* o = triggerRX = new Fl_Value_Input(260, 385, 65, 25, "rx");
              o->minimum(-180);
              o->maximum(360);
              o->step(1);
              o->callback((Fl_Callback*)cb_triggerRX);
            }
            { Fl_Value_Input* o = triggerRY = new Fl_Value_Input(345, 385, 65, 25, "ry");
              o->minimum(-180);
              o->maximum(360);
              o->step(1);
              o->callback((Fl_Callback*)cb_triggerRY);
            }
            { Fl_Value_Input* o = triggerRZ = new Fl_Value_Input(430, 385, 65, 25, "rz");
              o->minimum(-180);
              o->maximum(360);
              o->step(1);
              o->callback((Fl_Callback*)cb_triggerRZ);
            }
            { Fl_Value_Input* o = triggerTrigger = new Fl_Value_Input(300, 325, 75, 25, "Trigger");
              o->step(0.001);
              o->callback((Fl_Callback*)cb_triggerTrigger);
            }
            { Fl_Roller* o = triggerRoller = new Fl_Roller(390, 325, 120, 25);
              o->type(1);
              o->step(0.001);
              o->callback((Fl_Callback*)cb_triggerRoller);
            }
            o->end();
          }
          o->end();
        }
        { Fl_StageXY* o = stageXY = new Fl_StageXY(540, 90, 380, 335, "Stage Front View");
          o->box(FL_DOWN_FRAME);
          o->color(FL_BACKGROUND_COLOR);
          o->selection_color(FL_BACKGROUND_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(14);
          o->labelcolor(FL_BLACK);
          o->align(FL_ALIGN_TOP);
          o->when(FL_WHEN_RELEASE);
        }
        { Fl_StageZTrigger* o = stageYZTrigger = new Fl_StageZTrigger(10, 460, 520, 215, "Stage Side View");
          o->box(FL_DOWN_FRAME);
          o->color(FL_BACKGROUND_COLOR);
          o->selection_color(FL_BACKGROUND_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(14);
          o->labelcolor(FL_BLACK);
          o->align(FL_ALIGN_TOP);
          o->when(FL_WHEN_RELEASE);
          o->setView(1);
        }
        { Fl_Button* o = new Fl_Button(30, 100, 20, 25, "-y");
          o->callback((Fl_Callback*)cb_y);
        }
        { Fl_Button* o = new Fl_Button(50, 75, 55, 25, "Delete");
          o->callback((Fl_Callback*)cb_Delete);
        }
        { Fl_StageZTrigger* o = stageXZTrigger = new Fl_StageZTrigger(540, 460, 380, 215, "Stage Top View");
          o->box(FL_DOWN_FRAME);
          o->color(FL_BACKGROUND_COLOR);
          o->selection_color(FL_BACKGROUND_COLOR);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(14);
          o->labelcolor(FL_BLACK);
          o->align(FL_ALIGN_TOP);
          o->when(FL_WHEN_RELEASE);
          o->setView(0);
        }
        { Fl_Button* o = new Fl_Button(455, 435, 20, 20, "+");
          o->callback((Fl_Callback*)cb_2);
        }
        { Fl_Button* o = new Fl_Button(475, 435, 20, 20, "-");
          o->callback((Fl_Callback*)cb_3);
        }
        { Fl_Button* o = new Fl_Button(495, 435, 35, 20, "Orig");
          o->callback((Fl_Callback*)cb_Orig);
        }
        { Fl_Button* o = new Fl_Button(845, 435, 20, 20, "+");
          o->callback((Fl_Callback*)cb_4);
        }
        { Fl_Button* o = new Fl_Button(865, 435, 20, 20, "-");
          o->callback((Fl_Callback*)cb_5);
        }
        { Fl_Button* o = new Fl_Button(885, 435, 35, 20, "Orig");
          o->callback((Fl_Callback*)cb_Orig1);
        }
        { Fl_Slider* o = scrollYZTrigger = new Fl_Slider(10, 675, 520, 20);
          o->type(1);
          o->callback((Fl_Callback*)cb_scrollYZTrigger);
        }
        { Fl_Slider* o = scrollXZTrigger = new Fl_Slider(540, 675, 380, 20);
          o->type(1);
          o->callback((Fl_Callback*)cb_scrollXZTrigger);
        }
        valueYZTriggerBase = new Fl_Value_Output(45, 435, 60, 20, "base:");
        valueYZTriggerScale = new Fl_Value_Output(395, 435, 60, 20);
        valueXZTriggerBase = new Fl_Value_Output(580, 435, 60, 20, "base:");
        valueXZTriggerScale = new Fl_Value_Output(785, 435, 60, 20);
        { Fl_Button* o = new Fl_Button(50, 100, 125, 25, "Step and Repeat");
          o->callback((Fl_Callback*)cb_Step);
        }
        o->end();
      }
      { Fl_Group* o = new Fl_Group(10, 65, 920, 645, "Enemy");
        o->hide();
        { Fl_Browser* o = enemyList = new Fl_Browser(10, 95, 150, 480, "Enemy");
          o->type(2);
          o->callback((Fl_Callback*)cb_enemyList);
          o->align(FL_ALIGN_TOP);
        }
        { Fl_Group* o = new Fl_Group(170, 95, 680, 315, "Enemy Properties");
          o->box(FL_DOWN_BOX);
          o->align(FL_ALIGN_TOP_LEFT);
          { Fl_Input* o = explosionFirstColor = new Fl_Input(350, 120, 120, 25, "Explosion First Color");
            o->callback((Fl_Callback*)cb_explosionFirstColor);
          }
          { Fl_Input* o = explosionLastColor = new Fl_Input(350, 150, 120, 30, "Explosion Last Color");
            o->callback((Fl_Callback*)cb_explosionLastColor);
          }
          { Fl_Value_Input* o = explosionRadius = new Fl_Value_Input(350, 185, 65, 25, "Explosion Radius");
            o->maximum(1000);
            o->callback((Fl_Callback*)cb_explosionRadius);
          }
          { Fl_Value_Input* o = explosionHeight = new Fl_Value_Input(350, 215, 65, 25, "Explosion Height Factor");
            o->maximum(1000);
            o->callback((Fl_Callback*)cb_explosionHeight);
          }
          { Fl_Input* o = soundLockOn = new Fl_Input(350, 275, 295, 25, "Lock On Sound");
            o->callback((Fl_Callback*)cb_soundLockOn);
          }
          { Fl_Button* o = new Fl_Button(645, 275, 30, 25, "...");
            o->callback((Fl_Callback*)cb_6);
          }
          { Fl_Input* o = soundExplode = new Fl_Input(350, 305, 295, 25, "Explode Sound");
            o->callback((Fl_Callback*)cb_soundExplode);
          }
          { Fl_Button* o = new Fl_Button(645, 305, 30, 25, "...");
            o->callback((Fl_Callback*)cb_7);
          }
          { Fl_Value_Input* o = explosionDuration = new Fl_Value_Input(350, 245, 65, 25, "Explosion Duration (sec)");
            o->maximum(1000);
            o->callback((Fl_Callback*)cb_explosionDuration);
          }
          o->end();
        }
        o->end();
      }
      o->end();
    }
    o->end();
  }
  perspective_preview();
//make_trigger_ed()->show();
new_level();
  w->show(argc, argv);
  return Fl::run();
}

Fl_Double_Window *aboutBox=(Fl_Double_Window *)0;

static void cb_OK(Fl_Return_Button*, void*) {
  aboutBox->hide();
delete aboutBox;
aboutBox=0;
}

Fl_Double_Window* make_about() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = aboutBox = new Fl_Double_Window(280, 100, "About Resonate Editor");
    w = o;
    { Fl_Output* o = new Fl_Output(25, 25, 225, 30, "Resonate Level Editor by HardHat");
      o->align(FL_ALIGN_TOP);
      o->value("Version 0.9, 2008-04-22");
    }
    { Fl_Return_Button* o = new Fl_Return_Button(100, 65, 85, 25, "OK");
      o->callback((Fl_Callback*)cb_OK);
    }
    o->end();
  }
  return w;
}

void new_level() {
  reset_undo();
activeSegment=0;
dirty=0;
levelDuration->value(3);
levelSegments->value(8);
pathPosition->slider_size(1.0/8);
pathPosition->maximum(7);
bpm->value(148);
evoDropRate->value(8);
chaosDropRate->value(20);
initialEvo->value(0);
initialChaos->value(1);
int i;
for(i=0;i<256;i++) {
	segment[i].isTunnel=0;
	segment[i].visualization=1;
	segment[i].cameraAngle=0;
	segment[i].seed[0]=1/6.0f;
	segment[i].seed[1]=1/5.0f;
	segment[i].scale=50;
	segment[i].length=15;
	segment[i].fogNear=512;
	segment[i].fogFar=1024;
	segment[i].fogColor=0xc0c000;
	int p;
	for(p=0;p<256;p++) {
		int r,g,b;
		g=p<128?0:(p-128)+16;
		b=p<128?p+16:128+16;
		r=g;
		segment[i].palette[p]=r|(g<<8)|(b<<16);
	}
}
for(i=0;i<256;i++) {
	trigger[i].type[0]=0;
	trigger[i].segment=0;
	trigger[i].points=0;
	trigger[i].bonusType=0;
	trigger[i].health=1;
	trigger[i].stageCount=2;
	int j;
	for(j=0;j<8;j++) {
		trigger[i].stage[j].trigger=0;
		trigger[i].stage[j].pos[0]=0;
		trigger[i].stage[j].pos[1]=0;
		trigger[i].stage[j].pos[2]=0;
		trigger[i].stage[j].orient[0]=0;
		trigger[i].stage[j].orient[1]=0;
		trigger[i].stage[j].orient[2]=0;
	}
}
for(i=0;i<256;i++) {
	enemyModel[i].name[0]=0;
	enemyModel[i].explosionFirstColor=0x000030;
	enemyModel[i].explosionLastColor=0x003030;
	enemyModel[i].explosionDuration=1;
	enemyModel[i].explosionRadius=60;
	enemyModel[i].explosionHeightScale=1;
	enemyModel[i].lockOnSound[0]=0;
	enemyModel[i].explodeSound[0]=0;
}
pathPosition->value(0);
show_segment();
}

void open_level() {
  char *fname=fl_file_chooser("Open Level File","*.txt",0);
if(fname) {
printf("Attempting to load level '%s'\n",fname);
   strcpy(currentlevel,fname);
   load_level(fname);
}
activeSegment=0;
show_segment();
dirty=0;
}

void save_level() {
  if(strlen(currentlevel)>4) {
	save_level(currentlevel);
	char buf[512];
	char *s=strrchr(currentlevel,'/');
	if(!s) s=strrchr(currentlevel,'\\');
	if(s) s++;
	if(!s) s=currentlevel;
	sprintf(buf,"%s - Resonate Level Editor",s);
	rootWindow->label(buf);
	dirty=0;
} else {
	saveas_level();
}
}

void saveas_level() {
  char *fname=fl_file_chooser("Save As Level","*.txt",0);
if(fname) {
	strcpy(currentlevel,fname);
	save_level(fname);
}
}

void quit_editor() {
  exit(1);
}

void load_level(const char *fname) {
  FILE *file=fopen(fname,"r");

if(!file) {
	fl_ask("Failed to load level.");
	return;
}
new_level();
int firstSegment=0;
activeSegment=0;
activeTrigger=0;
activeEnemy=0;
while(triggerList->size()>0) {
	triggerList->remove(triggerList->size());
}
while(enemyList->size()>0) {
	enemyList->remove(enemyList->size());
}
int i;

char buf[256];
while(fgets(buf,255,file)) {
	buf[255]=0;
	if(buf[0]=='#') continue;
	if(strchr(buf,'\n')) strchr(buf,'\n')[0]=0;
	if(buf[0]=='[') {
		if(strcmp(buf,"[segment]")==0) {
			if(firstSegment++) activeSegment++;
			if(activeSegment>255) activeSegment=0;
		} else if(strcmp(buf,"[trigger]")==0) {
			activeTrigger++;
			if(activeTrigger>255) {
				activeTrigger=1;
			} else {
				sprintf(buf,"[trigger]%03d",triggerList->size()+1);
				triggerList->add(buf);
			}
		} else if(strcmp(buf,"[enemy]")==0) {
			activeEnemy++;
			if(activeEnemy>255) {
				activeEnemy=1;
			}
		}
	}
	char *value=strchr(buf,'=');
	if(value) {
		value[0]=0;
		value++;
		int i=0;
		float f=0;
		unsigned int u=0;
		sscanf(value,"%d",&i);
		sscanf(value,"%f",&f);
		sscanf(value,"0x%x",&u);
		if(strcmp(buf,"segments")==0) {
			levelSegments->value(i);
			if(i>0) {
				pathPosition->maximum(i-1);
				pathPosition->slider_size(1.0f/i);
			}
		} else if(strcmp(buf,"duration")==0) {
			levelDuration->value(f);
		} else if(strcmp(buf,"bpm")==0) {
			bpm->value(f);
		} else if(strcmp(buf,"evoDropRate")==0) {
			evoDropRate->value(f);
		} else if(strcmp(buf,"chaosDropRate")==0) {
			chaosDropRate->value(f);
		} else if(strcmp(buf,"initialChaos")==0) {
			initialChaos->value(f);
		} else if(strcmp(buf,"initialEvo")==0) {
			initialEvo->value(f);
		} else if(strcmp(buf,"song")==0) {
			song->value(value);
		} else if(strcmp(buf,"isTunnel")==0) {
			segment[activeSegment].isTunnel=i;
		} else if(strcmp(buf,"visualization")==0) {
			segment[activeSegment].visualization=i;
		} else if(strcmp(buf,"cameraAngle")==0) {
			segment[activeSegment].cameraAngle=i;
		} else if(strcmp(buf,"fogNear")==0) {
			segment[activeSegment].fogNear=f;
		} else if(strcmp(buf,"fogFar")==0) {
			segment[activeSegment].fogFar=f;
		} else if(strcmp(buf,"fogColor")==0) {
			segment[activeSegment].fogColor=u;
		} else if(strcmp(buf,"scale")==0) {
			segment[activeSegment].scale=f;
		} else if(strcmp(buf,"length")==0) {
			segment[activeSegment].length=f;
		} else if(strcmp(buf,"seedA")==0) {
			segment[activeSegment].seed[0]=f;
		} else if(strcmp(buf,"seedB")==0) {
			segment[activeSegment].seed[1]=f;
		} else if(strncmp(buf,"palette",7)==0) {
			int p=0;
			sscanf(buf,"palette%d",&p);
			if(p<0 || p>255) p=0;
			segment[activeSegment].palette[p]=u;
		} else if(strcmp(buf,"triggerType")==0) {
			strcpy(trigger[activeTrigger].type,value);
			triggerType->add(value);
			if(triggerType->size()==1) triggerType->value(0);
			strcpy(enemyModel[enemyList->size()].name,value);
		} else if(strcmp(buf,"triggerSegment")==0) {
			trigger[activeTrigger].segment=i;
		} else if(strcmp(buf,"health")==0) {
			trigger[activeTrigger].health=i;
		} else if(strcmp(buf,"points")==0) {
			trigger[activeTrigger].points=i;
		} else if(strcmp(buf,"bonusType")==0) {
			trigger[activeTrigger].bonusType=i;
		} else if(strcmp(buf,"stageCount")==0) {
			trigger[activeTrigger].stageCount=i;
		} else if(strncmp(buf,"stage",5)==0) {
			int st=0;
			char thing[255];
			sscanf(buf,"stage%d%s",&st,thing);
			if(st<0 || st>7) st=0;
			if(strcmp(thing,"x")==0) {
				trigger[activeTrigger].stage[st].pos[0]=f;
			} else if(strcmp(thing,"y")==0) {
				trigger[activeTrigger].stage[st].pos[1]=f;
			} else if(strcmp(thing,"z")==0) {
				trigger[activeTrigger].stage[st].pos[2]=f;
			} else if(strcmp(thing,"rx")==0) {
				trigger[activeTrigger].stage[st].orient[0]=f;
			} else if(strcmp(thing,"ry")==0) {
				trigger[activeTrigger].stage[st].orient[1]=f;
			} else if(strcmp(thing,"rz")==0) {
				trigger[activeTrigger].stage[st].orient[2]=f;
			} else if(strcmp(thing,"trigger")==0) {
				trigger[activeTrigger].stage[st].trigger=f;
			}
		} else if(strcmp(buf,"enemyModelName")==0) {
			strcpy(enemyModel[activeEnemy].name,value);
			enemyList->add(value);
		} else if(strcmp(buf,"explosionFirstColor")==0) {
			enemyModel[activeEnemy].explosionFirstColor=u;
		} else if(strcmp(buf,"explosionLastColor")==0) {
			enemyModel[activeEnemy].explosionLastColor=u;
		} else if(strcmp(buf,"explosionDuration")==0) {
			enemyModel[activeEnemy].explosionDuration=f;
		} else if(strcmp(buf,"explosionRadius")==0) {
			enemyModel[activeEnemy].explosionRadius=f;
		} else if(strcmp(buf,"explosionHeightScale")==0) {
			enemyModel[activeEnemy].explosionHeightScale=f;
		} else if(strcmp(buf,"lockOnSound")==0) {
			strcpy(enemyModel[activeEnemy].lockOnSound,value);
		} else if(strcmp(buf,"explodeSound")==0) {
			strcpy(enemyModel[activeEnemy].explodeSound,value);
		}
	}
}
for(i=0;i<activeTrigger;i++) {
	int j;
	for(j=0;j<256;j++) {
		if(strcmp(trigger[i].type,enemyModel[j].name)==0) break;
	}
	if(j<256) continue;
	enemyList->add(trigger[i].type);
	strcpy(enemyModel[activeEnemy].name,trigger[i].type);
	activeEnemy++;
}
fclose(file);
pathPosition->value(0);
activeSegment=0;
mapPosition->value(0);
show_segment();
}

void save_level(const char *fname) {
  char path[256];
strcpy(path,fname);
char *s=strrchr(path,'.');
if(!s || strcmp(s,".txt")!=0) strcat(path,".txt");

FILE *file=fopen(path,"w");

if(!file) {
	fl_ask("Couldn't create the file.  Bad filename?");
	return;
}
fprintf(file,"# Autogenerated level created in Resonate Editor\n");
fprintf(file,"[global]\nduration=%f\nsegments=%.0f\n",levelDuration->value(),levelSegments->value());
fprintf(file,"bpm=%f\n",bpm->value());
fprintf(file,"chaosDropRate=%d\n",(int)chaosDropRate->value());
fprintf(file,"initialChaos=%d\n",(int)initialChaos->value());
fprintf(file,"evoDropRate=%d\n",(int)evoDropRate->value());
fprintf(file,"initialEvo=%d\n",(int)initialEvo->value());
fprintf(file,"song=%s\n",(int)song->value());
fprintf(file,"\n");

int seg;
for(seg=0;seg<(int)levelSegments->value();seg++) {
	fprintf(file,"[segment]\n");
	fprintf(file,"isTunnel=%d\n",segment[seg].isTunnel);
	fprintf(file,"seedA=%f\n",segment[seg].seed[0]);
	fprintf(file,"seedB=%f\n",segment[seg].seed[1]);
	fprintf(file,"length=%f\n",segment[seg].length);
	fprintf(file,"scale=%f\n",segment[seg].scale);
	fprintf(file,"cameraAngle=%d\n",segment[seg].cameraAngle);
	fprintf(file,"visualization=%d\n",segment[seg].visualization);
	fprintf(file,"fogNear=%f\n",segment[seg].fogNear);
	fprintf(file,"fogFar=%f\n",segment[seg].fogFar);
	fprintf(file,"fogColor=0x%06x\n",segment[seg].fogColor);
	int p;
	for(p=0;p<256;p++) {
		fprintf(file,"palette%d=0x%06x\n",p,segment[seg].palette[p]&0xffffff);
	}
	fprintf(file,"\n");
}

int trig;
for(trig=1;trig<=triggerList->size();trig++) {
	fprintf(file,"[trigger]\n");
	fprintf(file,"triggerType=%s\n",trigger[trig].type);
	fprintf(file,"triggerSegment=%d\n",trigger[trig].segment);
	fprintf(file,"health=%d\n",trigger[trig].health);
	fprintf(file,"points=%d\n",trigger[trig].points);
	fprintf(file,"bonusType=%d\n",trigger[trig].bonusType);
	fprintf(file,"stageCount=%d\n",trigger[trig].stageCount);
	int st;
	for(st=0;st<trigger[trig].stageCount;st++) {
		fprintf(file,"stage%dtrigger=%g\n",st,trigger[trig].stage[st].trigger);
		fprintf(file,"stage%dx=%g\n",st,trigger[trig].stage[st].pos[0]);
		fprintf(file,"stage%dy=%g\n",st,trigger[trig].stage[st].pos[1]);
		fprintf(file,"stage%dz=%g\n",st,trigger[trig].stage[st].pos[2]);
		fprintf(file,"stage%drx=%g\n",st,trigger[trig].stage[st].orient[0]);
		fprintf(file,"stage%dry=%g\n",st,trigger[trig].stage[st].orient[1]);
		fprintf(file,"stage%drz=%g\n",st,trigger[trig].stage[st].orient[2]);
	}
	fprintf(file,"\n");
}

int en;
for(en=1;en<=enemyList->size();en++) {
	fprintf(file,"[enemy]\n");
	fprintf(file,"enemyModelName=%s\n",enemyModel[en].name);
	fprintf(file,"explosionFirstColor=#%06x\n",enemyModel[en].explosionFirstColor);
	fprintf(file,"explosionLastColor=#%06x\n",enemyModel[en].explosionLastColor);
	fprintf(file,"explosionRadius=%f\n",enemyModel[en].explosionRadius);
	fprintf(file,"explosionHeightScale=%f\n",enemyModel[en].explosionHeightScale);
	fprintf(file,"explosionDuration=%d\n",(int)(1000*enemyModel[en].explosionDuration));
	fprintf(file,"lockOnSound=%s\n",enemyModel[en].lockOnSound);
	fprintf(file,"explodeSound=%s\n",enemyModel[en].explodeSound);
	fprintf(file,"\n");
}

fclose(file);
}

void load_palette() {
  int i;

while(1) {
	char *fname=fl_file_chooser("Open PNG Image","*.png",0);
	if(fname) {
		Image *image=loadPng(fname);
		if(image) {
			unsigned long *data=(unsigned long *)image->data;
			for(i=0;i<256;i++) {
				segment[activeSegment].palette[i]=data[i];
			}
			freeImage(image);
			palettePreview->redraw();
		} else {
			if(fl_ask("Not a valid PNG.  Try another?")) continue;
			break;
		}
	}
	break;
}
genTerrain();
new_map();
}
static Image *imageVis;
static Image *colorMap;

void new_map() {
  Fl_Image *img=0;
static unsigned char raw[256*256*3];
Image *image=imageVis;
if(!image) image=newImage(256,256);
imageVis=image;
copyPalette(segment[activeSegment].palette);
if(colorMap) freeImage(colorMap);
colorMap=0;
if(segment[activeSegment].visualization!=4) {
	generateVisualization(segment[activeSegment].seed[0],segment[activeSegment].seed[1],image,segment[activeSegment].visualization);
} else {
	char fname[256];
	strcpy(fname,currentlevel);
	char *s=fname;
	if(strrchr(fname,'.')) s=strrchr(fname,'.');
	sprintf(s,"seg%dheight.png",activeSegment);
	image=loadPng(fname);
	if(image) {
		if(image->textureWidth!=256 || image->textureHeight!=256) {
			fl_alert("height image is not the required 256x256");
			freeImage(image);
			image=imageVis;
		} else {
			if(imageVis) freeImage(imageVis);
			imageVis=image;
		}
	} else {
		char buf[512];
		strcpy(buf,"Couldn't find custom level file\n");
		strcat(buf,fname);
		strcat(buf,"\nSearch for one now?");
		if(fl_ask(buf)) {
			char *imagename=fl_file_chooser("Open Level File","*.png",0);
			if(imagename) {
				file_copy(imagename,fname);
				image=loadPng(fname);
				if(image && image->textureWidth==256 && image->textureHeight==256) {
					if(imageVis) freeImage(imageVis);
					imageVis=image;
				} else if(image) {
					sprintf(buf,"Image must be 256x256 not %dx%d\n",image->imageWidth,image->imageHeight);
					fl_alert(buf);
					freeImage(image);
					image=imageVis;
				} else {
					fl_alert("Unable to load image.  Is it a valad PNG?");
					image=imageVis;
				}
			} else {
				image=imageVis;
			}
		} else {
			image=imageVis;
		}
	}
	sprintf(s,"seg%dcolor.png",activeSegment);
	colorMap=loadPng(fname);
	if(colorMap && (colorMap->textureWidth!=256 || colorMap->textureHeight!=256)) {
		fl_alert("Color map is not the required 256x256");
		freeImage(colorMap);
		colorMap=0;
	}
}
int i,j,pos=0;
for(j=0;j<256;j++) {
	for(i=0;i<256;i++) {
		unsigned int color=image->data[i*image->imageHeight/256*image->textureWidth+j*image->imageWidth/256];
		raw[pos*3+2]=color>>16;
		raw[pos*3+1]=color>>8;
		raw[pos*3]=color;
		pos++;
	}
}
img=new Fl_RGB_Image(raw,256,256,3);
Fl_RGB_Image *old=(Fl_RGB_Image *)mapPreview->image();
mapPreview->image(img);
if(old) delete old;
printf("New map generated.\n");
mapPreview->redraw();
perspectivePreview->redraw();
}

void show_segment() {
  switch(segment[activeSegment].visualization) {
case 1: visPlasma->setonly(); break;
case 2: visJulia->setonly(); break;;
case 3: visWallp2->setonly(); break;
case 4: visCustom->setonly(); break;
default: visWallp->setonly(); break;
}
switch(segment[activeSegment].cameraAngle) {
case 1: buttonLeft->setonly(); break;
case 2: buttonRight->setonly(); break;
default: buttonFront->setonly(); break;
}
isTunnel->value(segment[activeSegment].isTunnel);
segHeight->value(segment[activeSegment].scale);
segLength->value(segment[activeSegment].length);
seedA->value(segment[activeSegment].seed[0]);
seedB->value(segment[activeSegment].seed[1]);
fogNear->value(segment[activeSegment].fogNear);
fogFar->value(segment[activeSegment].fogFar);
char buf[256];
sprintf(buf,"#%06x",segment[activeSegment].fogColor);
fogColor->value(buf);
palettePreview->redraw();
new_map();
}

void hue_palette(float hue) {
  int i;
int left,right;
float hr=0,hg=0,hb=0;
int r,g,b;

if(hue<1/3.0f) {
	hr=1.0-(hue*3);
	hg=hue*3;
} else if(hue>2/3.0f) {
	hb=1.0-(hue*3-2);
	hr=hue*3-2;
} else {
	hg=1.0-(hue*3-1);
	hb=hue*3-1;
}

for(i=0;i<128;i++) {
	left=0;
	right=i+16;
	r=(int)(left*hr+(1-hr)*right);
	g=(int)(left*hg+(1-hg)*right);
	b=(int)(left*hb+(1-hb)*right);
	segment[activeSegment].palette[i]=r|(g<<8)|(b<<16);		
}
for(i=128;i<255;i++) {
	left=i-128+16;
	right=128+16;
	r=(int)(left*hr+(1-hr)*right);
	g=(int)(left*hg+(1-hg)*right);
	b=(int)(left*hb+(1-hb)*right);
	segment[activeSegment].palette[i]=r|(g<<8)|(b<<16);		
}
}

Fl_Perspective_Preview::Fl_Perspective_Preview(int x,int y,int w,int h,const char *s) : Fl_Gl_Window(x,y,w,h,s) {
  vert=0;
image=0;
grid=128;
theta=0;
phi=0;
refresh=0;
model=(struct Model *)calloc(sizeof(struct Model),256);
printf("perspective preview constructor\n");
}

void Fl_Perspective_Preview::draw() {
  refresh++;
if(!valid()) {
	// Set up projection, viewport, etc.
	glViewport(0,0,w(),h());
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f,(double)w()/(double)h(),2.0f,1024.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
}
glMatrixMode(GL_MODELVIEW);
glLoadIdentity();
static float targetFrom[3];
static float from[3];
float to[3];
float pathPos;
int tile=256/grid;
pathPos=mapPosition->value();
to[0]=0;
to[1]=0;
to[2]=pathPos*grid*tile*segment[activeSegment].length;
targetFrom[0]=to[0];
targetFrom[1]=to[1]+85;
targetFrom[2]=to[2];
switch(segment[activeSegment].cameraAngle) {
case 1:
	targetFrom[0]+=-155;
	break; // left
case 2:
	targetFrom[0]+=155;
	break; // right
default: targetFrom[2]-=155; break; // forward
}
//from[0]=from[0]*0.95f+targetFrom[0]*0.05f;
//from[1]=from[1]*0.95f+targetFrom[1]*0.05f;
//from[2]=from[2]*0.95f+targetFrom[2]*0.05f;
from[0]=targetFrom[0];
from[1]=targetFrom[1];
from[2]=targetFrom[2];
if(theta!=0 || phi!=0) {
	// rotate about theta, then phi.
	/*
	float x,y,z;
	x=from[0]-to[0];
	y=from[1]-to[1];
	z=from[2]-to[2];
	*/
	float ct=cosf(theta),st=sinf(theta),cp=cosf(phi),sp=sinf(phi);
	float dist=155;
	from[0]=dist*ct*sp;
	from[1]=dist*st;
	from[2]=-dist*ct*cp;

	from[0]+=to[0];
	from[1]+=to[1];
	from[2]+=to[2];
}
//printf("Th: %.3f Ph: %.3f (%.3f,%.3f,%.3f)\n",theta,phi,from[0],from[1],from[2]);
gluLookAt(from[0],from[1],from[2],to[0],to[1],to[2],0,1,0);

float d[3];
d[0]=from[0]-targetFrom[0];
d[1]=from[1]-targetFrom[1];
d[2]=from[2]-targetFrom[2];
//if(d[0]*d[0]+d[1]*d[1]+d[2]*d[2]>0.01f*0.01f) this->redraw();	// Not yet stable.


float fog[4];
unsigned int fogColor=segment[activeSegment].fogColor;
fog[0]=((fogColor)&255)/255.0f;
fog[1]=((fogColor>>8)&255)/255.0f;
fog[2]=((fogColor>>16)&255)/255.0f;
fog[3]=1.0f;
glClearColor(fog[0],fog[1],fog[2],1);	// Fog coloured background
glClearDepth(1.0f);
glFogfv(GL_FOG_COLOR, fog);
//glHint(GL_FOG_HINT, GL_DONT_CARE);
glFogf(GL_FOG_START,segment[activeSegment].fogNear);
glFogf(GL_FOG_END,segment[activeSegment].fogFar);
glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

glDisable(GL_CULL_FACE);
//glFrontFace(GL_CCW);
//glEnable(GL_FOG);
drawTerrainGL();
glDisable(GL_FOG);
//glEnable(GL_CULL_FACE);
drawActors();
}

void Fl_Perspective_Preview::drawTerrainGL() {
  genTerrain();
if(!vert) return;

int i;
int j;
for(j=0;j<grid-1;j++) {
	glBegin(GL_TRIANGLE_STRIP);
	for(i=0;i<(grid-1)*2+1;i++) {
		int id=i+j*((grid-1)*2+1);
		//if((id&127)==64) printf("Color %06x;",vert[id].color);
		glColor4f(((vert[id].color)&255)/255.0f,((vert[id].color>>8)&255)/255.0f,((vert[id].color>>16)&255)/255.0f,1.0f);
		glNormal3f(vert[id].nx,vert[id].ny,vert[id].nz);
		glVertex3f(vert[id].x,vert[id].y,vert[id].z);
	};
	//printf("\n");
	glEnd();
}
}

void Fl_Perspective_Preview::genTerrain() {
  if(vert) free(vert);
vert=(Vertex3DCNP *)calloc(sizeof(Vertex3DCNP)*grid*grid*2,1);

if(!image) {
	image=newImage(256,256);
}
int p;
unsigned int palette[256];
for(p=0;p<255;p++) palette[p]=(p)|(p<<8)|(p<<16);

copyPalette(palette);
if(segment[activeSegment].visualization==4) {
	char buf[256];
	char *s=buf;
	strcpy(buf,currentlevel);
	if(strrchr(buf,'.')) s=strrchr(buf,'.');
	sprintf(s,"seg%dheight.png",activeSegment);
	Image *im=loadPng(buf);
	if(im && im->textureWidth==256 && im->textureHeight==256) {
		freeImage(image);
		image=im;
	}
} else {
	generateVisualization(segment[activeSegment].seed[0],segment[activeSegment].seed[1],image,segment[activeSegment].visualization);
}
//saveImagePng("test.png",image->data,256,256,256,0);
int tile=256/grid;

int i,j,k;
for(i=0;i<grid-1;i++) {
	for(j=0;j<grid;j++) {
		for(k=0;k<2;k++) {
			Vertex3DCNP *v=vert+(i*grid+j)*2+k;
			int offset=(i+k)*tile*image->textureWidth+j*tile;
			unsigned int terrainZ=(image->data[offset]&0xff);
			unsigned int color=segment[activeSegment].palette[terrainZ];
			if(colorMap && image->textureWidth==colorMap->textureWidth && colorMap->textureWidth && image->textureHeight==colorMap->textureHeight) {
				color=colorMap->data[offset];
			}

			v->color=color;
			v->x=((i+k)-grid/2)*tile*segment[activeSegment].length;
			v->z=(j)*tile*segment[activeSegment].length;
			v->y=((int)terrainZ-255)*(1/255.0f)*segment[activeSegment].scale-155;

			if(segment[activeSegment].isTunnel) {
				// Transform x and y into a circle.
				float angle=(i+k+grid/4)/(float)(grid-2)*3.1415926535f*2;
				float y=v->y;
				v->x=cosf(angle)*(25-y);
				v->y=sinf(angle)*(25-y);
			}

			// Lazy normals:
			v->nx=0;
			v->ny=1;
			v->nz=0;
		}
	}
}

#if 0
FILE *file=fopen("test.obj","w");
if(file) {
	fprintf(file,"# segment: %d; length: %.3f; scale=%.3f; grid=%d\n",activeSegment,segment[activeSegment].length,segment[activeSegment].scale,grid);
	for(i=0;i<grid-1;i++) {
		fprintf(file,"# Grid strip %d\n",i);
		for(j=0;j<grid;j++) {
			for(k=0;k<2;k++) {
				int id=(i*grid+j)*2+k;
				fprintf(file,"v %.4f %.4f %.4f\n",vert[i].x,vert[i].y,vert[i].z);
				if(j>0 && k==1) fprintf(file,"f -1 -2 -3\n");
				else if(j>0 && k==0) fprintf(file,"f -1 -3 -2\n");
			}
		}
	}
	fclose(file);
}
#endif
}

int Fl_Perspective_Preview::handle(int event) {
  static int ox,oy;
static float opos;
static bool editPos=false;
int x,y;
switch(event) {
case FL_PUSH:
	if(Fl::event_button3()) editPos=true; else editPos=false;
	opos=mapPosition->value();
	ox=Fl::event_x();
	oy=Fl::event_y();
	redraw();
	return 1;
	break;
case FL_DRAG:
	x=Fl::event_x();
	y=Fl::event_y();
	if(!editPos) {
		phi=(x-ox)*(1/100.0f);
		theta=(y-oy)*(1/100.0f);
	} else {
		float pos=opos+(oy-y)/(float)h();
		if(pos<0) pos=0;
		if(pos>1) pos=1;
		mapPosition->value(pos);
	}
	redraw();
	return 1;
	break;
case FL_RELEASE:
	theta=0;
	phi=0;
	redraw();
	return 1;
	break;
}
return 0;
}

void Fl_Perspective_Preview::drawActors() {
  float z=mapPosition->value()*256*segment[activeSegment].length;

float w=20;
float h=20;
// Hero is a triangle
glBegin(GL_TRIANGLES);
	glColor4f(1,1,1,1);
	glVertex3f(0,-35+h,z);	// y=-35 is magic constant.
	glVertex3f(-w,-35-h,z);
	glVertex3f(w,-35-h,z);

	glVertex3f(0,-35+h,z);	// y=-35 is magic constant.
	glVertex3f(0,-35-h,z-w);
	glVertex3f(0,-35-h,z+w);
glEnd();

int i;
// Enemies are squares
for(i=1;i<=triggerList->size();i++) {
	if(trigger[i].segment!=activeSegment) continue;

	int j;
	for(j=0;j<trigger[i].stageCount-1;j++) {
		glBegin(GL_LINES);
			if(activeTrigger==i)
				glColor4f(1,1,1,1);
			else
				glColor4f(1,0.6f,1,1);
			glVertex3f(trigger[i].stage[j].pos[0],
				trigger[i].stage[j].pos[1],
				trigger[i].stage[j].pos[2]);
			glVertex3f(trigger[i].stage[j+1].pos[0],
				trigger[i].stage[j+1].pos[1],
				trigger[i].stage[j+1].pos[2]);
		glEnd();
	}
	for(j=0;j<trigger[i].stageCount;j++) {
		int k;
		float dx[]={-5,5,5,-5},dy[]={-5,-5,5,5};
		glBegin(GL_TRIANGLE_FAN);
			if(activeTrigger==i)
				if(activeStage==j)
					glColor4f(1,0.2f,0.2f,1);
				else
					glColor4f(0.6f,0.2f,0.6f,1);
			else
				glColor4f(0.6f,0,0.6f,1);
			for(k=0;k<4;k++) {
				glVertex3f(trigger[i].stage[j].pos[0]+dx[k],trigger[i].stage[j].pos[1]+dy[k],trigger[i].stage[j].pos[2]);
			}
		glEnd();
		glBegin(GL_TRIANGLE_FAN);
			if(activeTrigger==i)
				if(activeStage==j)
					glColor4f(1,0.2f,0.2f,1);
				else
					glColor4f(0.6f,0.2f,0.6f,1);
			else
				glColor4f(0.6f,0,0.6f,1);
			for(k=0;k<4;k++) {
				glVertex3f(trigger[i].stage[j].pos[0],trigger[i].stage[j].pos[1]+dy[k],trigger[i].stage[j].pos[2]+dx[k]);
			}
		glEnd();
	}
	// Now draw it where it would really be.
	for(j=0;j<trigger[i].stageCount-1;j++) {
		if(mapPosition->value()<trigger[i].stage[j].trigger) continue;
		if(mapPosition->value()>trigger[i].stage[j+1].trigger) continue;
		// in the range.
		break;
	}
	if(j<trigger[i].stageCount-1) {
		float x,y;
		float per=1,cent=0;
		float delta=trigger[i].stage[j+1].trigger-trigger[i].stage[j].trigger;
		if(delta>0) {
			cent=(mapPosition->value()-trigger[i].stage[j].trigger)/delta;
			per=1.0f-cent;
		}
		//printf("pos=%g; j=%d;",mapPosition->value(),j);
		//printf("delta=%g; per=%g, cent=%g;\n",delta,per,cent);
		x=trigger[i].stage[j].pos[0]*per+trigger[i].stage[j+1].pos[0]*cent;
		y=trigger[i].stage[j].pos[1]*per+trigger[i].stage[j+1].pos[1]*cent;
		z=trigger[i].stage[j].pos[2]*per+trigger[i].stage[j+1].pos[2]*cent;
		AnimMesh *mesh=findModel(trigger[i].type);
		if(mesh) {
			glPushMatrix();
			glTranslatef(x,y,z);
			drawActor(mesh);
			glPopMatrix();
		} else {
			int k;
			float dx[]={-15,15,15,-15},dy[]={-15,-15,15,15};
			glBegin(GL_TRIANGLE_FAN);
				if(activeTrigger==i)
					glColor4f(1,0.2f,0.2f,1);
				else
					glColor4f(0.6f,0.2f,0.6f,1);
				for(k=0;k<4;k++) {
					glVertex3f(x+dx[k],y+dy[k],z);
				}
			glEnd();
			glBegin(GL_TRIANGLE_FAN);
				if(activeTrigger==i)
					glColor4f(1,0.2f,0.2f,1);
				else
					glColor4f(0.6f,0.2f,0.6f,1);
				for(k=0;k<4;k++) {
					glVertex3f(x,y+dy[k],z+dx[k]);
				}
			glEnd();
		}
	}
}
}

void Fl_Perspective_Preview::drawActor(class AnimMesh *mesh) {
  if(!mesh) return;
Vertex3DTP *vert=(Vertex3DTP *)malloc(sizeof(Vertex3DTP)*mesh->polyCount*3);
if(!vert) return;
float minMax[6];
int base=0;
int max=mesh->frameCount;
if(max>=196) {
	base=40;
	max=6;
}
int frame=(refresh%max)+base;
md2GetFractionalFrame(mesh,frame,1,0,vert,minMax);
// what about textures?
glBegin(GL_TRIANGLES);
int i;
for(i=0;i<mesh->polyCount*3;i++) {
	if(mesh->texture) {
		Image *image=mesh->texture;
		int x=(int)(image->imageWidth*vert[i].u);
		int y=(int)(image->imageHeight*vert[i].v);
		while(x<0) x+=image->imageWidth;
		while(x>=image->imageWidth) x-=image->imageWidth;
		while(y<0) y+=image->imageHeight;
		while(y>=image->imageHeight) y-=image->imageHeight;
		unsigned int color=image->data[x+y*image->textureWidth];
		glColor4f((color&0xff)/255.0f,((color>>8)&0xff)/255.0f,((color>>16)&0xff)/255.0f,((color>>24)&0xff)/255.0f);
	} else {
		glColor4f(1,1,1,1);
	}
	glVertex3f(vert[i].x,vert[i].y,vert[i].z);
}
glEnd();
}

AnimMesh * Fl_Perspective_Preview::findModel(const char *fname) {
  if(strlen(fname)<5) return 0;
int i;
for(i=0;i<modelCount;i++) {
	if(strcmp(fname,model[i].name)==0) {
		return model[i].mesh;
	}
}
// now try a few places to find the path.
char path[256];
// Assume success
strcpy(model[i].name,fname);
modelCount++;
// Try hard to load
char *relpath[]={"","models/","../models/","../../models/",
	"resonate/models/","../resonate/models/","../../resonate/models/"};

int j;
for(j=0;j<7;j++) {
	sprintf(path,"%s%s",relpath[j],fname);
	model[i].mesh=md2Load(path);
	if(model[i].mesh) {
		char *s=strrchr(path,'.');
		if(s) strcpy(strrchr(path,'.'),".png");
		model[i].mesh->texture=loadPng(path);
		return model[i].mesh;
	}
}
// I just don't know where to look I guess.
modelCount--;
return 0;
}

void perspective_preview() {
  perspectivePreview=new Fl_Perspective_Preview(500,800,480,272,"Resonate Perspective Preview");
perspectivePreview->show();
}

void genTerrain() {
  if(perspectivePreview) {
	perspectivePreview->genTerrain();
}
}

Fl_Double_Window* make_trigger_ed() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = new Fl_Double_Window(927, 628, "Resonate Trigger Editor");
    w = o;
    o->end();
  }
  return w;
}

void update_stage() {
  triggerX->value(trigger[activeTrigger].stage[activeStage].pos[0]);
triggerY->value(trigger[activeTrigger].stage[activeStage].pos[1]);
triggerZ->value(trigger[activeTrigger].stage[activeStage].pos[2]);
triggerRX->value(trigger[activeTrigger].stage[activeStage].orient[0]);
triggerRY->value(trigger[activeTrigger].stage[activeStage].orient[1]);
triggerRZ->value(trigger[activeTrigger].stage[activeStage].orient[2]);
triggerTrigger->value(trigger[activeTrigger].stage[activeStage].trigger);
stageXY->redraw();
stageYZTrigger->redraw();
stageXZTrigger->redraw();
if(perspectivePreview) perspectivePreview->redraw();
}

void update_trigger() {
  int i;
activeStage=0;
triggerSegment->value(trigger[activeTrigger].segment);
activeSegment=trigger[activeTrigger].segment;
char buf[256];
int triggerSeg=(int)triggerSegment->value();
sprintf(buf,"seg%02dtgt%02d",triggerSeg,activeTrigger);
triggerName->value(buf);
triggerList->text(activeTrigger,buf);
triggerBonus->value(trigger[activeTrigger].bonusType);
triggerScore->value(trigger[activeTrigger].points);
triggerHitPoints->value(trigger[activeTrigger].health);
triggerBonus->value(trigger[activeTrigger].bonusType);
if(strlen(trigger[activeTrigger].type)>0) {
	for(i=0;i<triggerType->size();i++) {
		if( strcmp(trigger[activeTrigger].type,triggerType->text(i))==0 ) break;
	}
	if(i<triggerType->size()) triggerType->value(i);
	else triggerType->add(trigger[activeTrigger].type);
} else {
	if(triggerType->size()>0) strcpy(trigger[activeTrigger].type,triggerType->text());
}

if(trigger[activeTrigger].stageCount<2) trigger[activeTrigger].stageCount=2;
triggerStage->value(0);
triggerStage->maximum(trigger[activeTrigger].stageCount-1.0f);
triggerStage->slider_size(1.0f/trigger[activeTrigger].stageCount);
triggerStageCount->value(trigger[activeTrigger].stageCount);
stageXZTrigger->base=0.0f;	// Reset scale to orig.
stageXZTrigger->scale=1;
scrollXZTrigger->slider_size(1);
scrollXZTrigger->value(0);
stageYZTrigger->base=0.0f;
stageYZTrigger->scale=1;
scrollYZTrigger->slider_size(1);
scrollYZTrigger->value(0);
update_stage();
}

void update_enemy() {
  char buf[256];
sprintf(buf,"#%06x",enemyModel[activeEnemy].explosionFirstColor);
explosionFirstColor->value(buf);
sprintf(buf,"#%06x",enemyModel[activeEnemy].explosionLastColor);
explosionLastColor->value(buf);
explosionRadius->value(enemyModel[activeEnemy].explosionRadius);
explosionHeight->value(enemyModel[activeEnemy].explosionHeightScale);
explosionDuration->value(enemyModel[activeEnemy].explosionDuration);
soundLockOn->value(enemyModel[activeEnemy].lockOnSound);
soundExplode->value(enemyModel[activeEnemy].explodeSound);
}

void update_scale(Fl_StageZTrigger *stageZTrigger,Fl_Slider *scrollZTrigger) {
  if(stageZTrigger->base+1/stageZTrigger->scale>1.0) {
	stageZTrigger->base=1.0f-1/stageZTrigger->scale;
}
if(stageZTrigger->base<0) stageZTrigger->base=0;
stageZTrigger->redraw();
scrollZTrigger->value(stageZTrigger->base);
scrollZTrigger->slider_size(1/stageZTrigger->scale);
if(1.0f-1/stageZTrigger->scale>0) {
	scrollZTrigger->maximum(1.0f-1/stageZTrigger->scale);
}
if(stageZTrigger->showY) {
	valueYZTriggerBase->value(stageZTrigger->base);
	valueYZTriggerScale->value(stageZTrigger->scale);
} else {
	valueXZTriggerBase->value(stageZTrigger->base);
	valueXZTriggerScale->value(stageZTrigger->scale);
}
}

int file_copy(const char *from,const char *to) {
  FILE *in=fopen(from,"rb");
FILE *out=fopen(to,"wb");
if(in && out) {
	char buffer[4096];
	while(!feof(in)) {
		int len=fread(buffer,1,4096,in);
		if(len==0) break;
		fwrite(buffer,1,len,out);
	}
}
if(in) fclose(in);
if(out) fclose(out);
if(!in || !out) return -1;	// error.
return 0;
}

Fl_Double_Window *stepAndRepeat=(Fl_Double_Window *)0;

Fl_Value_Input *snrCount=(Fl_Value_Input *)0;

Fl_Value_Input *snrAngle=(Fl_Value_Input *)0;

Fl_Value_Input *snrCentreX=(Fl_Value_Input *)0;

Fl_Value_Input *snrCentreXInc=(Fl_Value_Input *)0;

Fl_Value_Input *snrCentreY=(Fl_Value_Input *)0;

Fl_Value_Input *snrCentreYInc=(Fl_Value_Input *)0;

Fl_Value_Input *snrTriggerInc=(Fl_Value_Input *)0;

static void cb_snrTriggerInc(Fl_Value_Input*, void*) {
  char buf[256];
sprintf(buf,"%.3f t = %.1f Z",snrTriggerInc->value(),snrTriggerInc->value()*256*segment[activeSegment].length);
snrConversion->value(buf);
}

Fl_Value_Input *snrZInc=(Fl_Value_Input *)0;

static void cb_snrZInc(Fl_Value_Input*, void*) {
  char buf[256];
float ratio=256*segment[activeSegment].length;
if(ratio==0) ratio=1;
sprintf(buf,"%.1f Z = %.3f t",snrZInc->value(),snrZInc->value()/ratio);
snrConversion->value(buf);
}

Fl_Value_Input *snrRXInc=(Fl_Value_Input *)0;

Fl_Value_Input *snrRYInc=(Fl_Value_Input *)0;

Fl_Value_Input *snrRZInc=(Fl_Value_Input *)0;

static void cb_OK1(Fl_Return_Button*, void*) {
  save_undo(UR_STEPANDREPEAT);
int count=0;
int countMax=(int)snrCount->value();
float dangle=snrAngle->value()*(M_PI/180);
float dx=snrCentreXInc->value();
float dy=snrCentreYInc->value();
float cx=snrCentreX->value();
float cy=snrCentreY->value();
float dt=snrTriggerInc->value();
float dz=snrZInc->value();
float drx=snrRXInc->value();
float dry=snrRYInc->value();
float drz=snrRZInc->value();

for(count=1;count<=countMax;count++) {
	int i=triggerList->size()+1;
	triggerList->add("StepAndRepeat");
	strcpy(trigger[i].type,trigger[activeTrigger].type);
	trigger[i].segment=trigger[activeTrigger].segment;
	trigger[i].health=trigger[activeTrigger].health;
	trigger[i].points=trigger[activeTrigger].points;
	trigger[i].bonusType=trigger[activeTrigger].bonusType;
	trigger[i].stageCount=trigger[activeTrigger].stageCount;
	int j;
	for(j=0;j<trigger[activeTrigger].stageCount;j++) {
		float angle=dangle*count;
		trigger[i].stage[j].trigger=trigger[activeTrigger].stage[j].trigger+dt*count;
		float x=trigger[activeTrigger].stage[j].pos[0]-cx+dx*count;
		float y=trigger[activeTrigger].stage[j].pos[1]-cy+dy*count;
		trigger[i].stage[j].pos[0]=x*cosf(angle)+y*sinf(angle)+cx;
		trigger[i].stage[j].pos[1]=-x*sinf(angle)+y*cosf(angle)+cy;
		trigger[i].stage[j].pos[2]=trigger[activeTrigger].stage[j].pos[2]+dz*count;
		trigger[i].stage[j].orient[0]=trigger[activeTrigger].stage[j].orient[0]+drx*count;
		trigger[i].stage[j].orient[1]=trigger[activeTrigger].stage[j].orient[1]+dry*count;
		trigger[i].stage[j].orient[2]=trigger[activeTrigger].stage[j].orient[2]+drz*count;
	}
}
stepAndRepeat->hide();
delete stepAndRepeat;
stepAndRepeat=0;
}

Fl_Output *snrConversion=(Fl_Output *)0;

static void cb_Match(Fl_Button*, void*) {
  snrZInc->value(snrTriggerInc->value()*256*segment[activeSegment].length);
}

static void cb_Match1(Fl_Button*, void*) {
  float ratio=(256*segment[activeSegment].length);
if(ratio==0) ratio=1;
snrTriggerInc->value(snrZInc->value()/ratio);
}

static void cb_Reset(Fl_Button*, void*) {
  snrCount->value(1);
snrAngle->value(0);
snrCentreX->value(0);
snrCentreY->value(-35);
snrCentreXInc->value(0);
snrCentreYInc->value(0);
snrTriggerInc->value(0);
snrZInc->value(0);
snrRXInc->value(0);
snrRYInc->value(0);
snrRXInc->value(0);
}

Fl_Double_Window* make_stepandrepeat() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = stepAndRepeat = new Fl_Double_Window(345, 335, "Resonate - Step and Repeat");
    w = o;
    { Fl_Value_Input* o = snrCount = new Fl_Value_Input(65, 5, 60, 25, "Count");
      o->maximum(255);
      o->step(1);
    }
    { Fl_Value_Input* o = snrAngle = new Fl_Value_Input(280, 35, 60, 25, "Angle Increment");
      o->minimum(-360);
      o->maximum(360);
      o->step(1);
    }
    { Fl_Value_Input* o = snrCentreX = new Fl_Value_Input(65, 65, 60, 25, "Centre X");
      o->minimum(-200);
      o->maximum(200);
      o->step(0.1);
    }
    { Fl_Value_Input* o = snrCentreXInc = new Fl_Value_Input(280, 65, 60, 25, "Centre X Increment");
      o->minimum(-200);
      o->maximum(200);
      o->step(0.1);
    }
    { Fl_Value_Input* o = snrCentreY = new Fl_Value_Input(65, 95, 60, 25, "Centre Y");
      o->minimum(-200);
      o->maximum(200);
      o->step(0.1);
    }
    { Fl_Value_Input* o = snrCentreYInc = new Fl_Value_Input(280, 95, 60, 25, "Centre Y Increment");
      o->minimum(-200);
      o->maximum(200);
      o->step(0.1);
    }
    { Fl_Value_Input* o = snrTriggerInc = new Fl_Value_Input(280, 125, 60, 25, "Trigger Increment");
      o->step(0.001);
      o->callback((Fl_Callback*)cb_snrTriggerInc);
    }
    { Fl_Value_Input* o = snrZInc = new Fl_Value_Input(280, 155, 60, 25, "Z Increment");
      o->minimum(-2000);
      o->maximum(2000);
      o->step(1);
      o->callback((Fl_Callback*)cb_snrZInc);
    }
    { Fl_Value_Input* o = snrRXInc = new Fl_Value_Input(280, 215, 60, 25, "Rotate X Increment");
      o->minimum(-360);
      o->maximum(360);
      o->step(1);
    }
    { Fl_Value_Input* o = snrRYInc = new Fl_Value_Input(280, 245, 60, 25, "Rotate Y Increment");
      o->minimum(-360);
      o->maximum(360);
      o->step(1);
    }
    { Fl_Value_Input* o = snrRZInc = new Fl_Value_Input(280, 275, 60, 25, "Rotate Z Increment");
      o->minimum(-360);
      o->maximum(360);
      o->step(1);
    }
    { Fl_Return_Button* o = new Fl_Return_Button(10, 305, 75, 25, "OK");
      o->callback((Fl_Callback*)cb_OK1);
    }
    snrConversion = new Fl_Output(170, 185, 170, 25, "Z/Trigger Conversion");
    { Fl_Button* o = new Fl_Button(5, 150, 120, 25, "Match to Trigger");
      o->callback((Fl_Callback*)cb_Match);
    }
    { Fl_Button* o = new Fl_Button(5, 125, 120, 25, "Match to Z");
      o->callback((Fl_Callback*)cb_Match1);
    }
    { Fl_Button* o = new Fl_Button(95, 305, 95, 25, "Reset");
      o->callback((Fl_Callback*)cb_Reset);
    }
    o->end();
  }
  return w;
}
#include <time.h>

UndoRedo::UndoRedo() {
  triggerId=0;
triggerIdCount=0;
stageId=0;
trigger=0;
changed=0;
}
#include <deque>
static std::deque<UndoRedo> undoList;

void save_undo(int urType) {
  UndoRedo node;
int i,max;
time_t now;
time(&now);
if(undoList.size()>0 && urType==undoList.back().type && now<=undoList.back().changed+2) {
	if(urType==UR_SELECTION || urType==UR_CHANGE) {
		// consolidate quick changes.
		undoList.back().changed=now;
		return;	
	}
}

node.type=urType;
node.changed=now;
node.triggerId=activeTrigger;
node.stageId=activeStage;
switch(urType) {
case UR_SELECTION:
	break;
case UR_CHANGE:
	node.trigger=new Trigger(trigger[activeTrigger]);
	break;
case UR_ADD:
	node.triggerId=triggerList->size()+1;
	break;
case UR_DELETE:
	node.trigger=new Trigger(trigger[activeTrigger]);
	break;
case UR_STEPANDREPEAT:
	max=(int)snrCount->value();
	node.triggerIdCount=max;
	break;
}

undoList.push_back( node);

static char undobuf[256];
strcpy(undobuf,"Undo ");
strcat(undobuf,undo_type());
undoMenuItem->label(undobuf);
}

void reset_undo() {
  int i;
while(undoList.empty()==false) {
	// Free any leaked memory here.
	if(undoList.back().trigger) {
		free(undoList.back().trigger);
		undoList.back().trigger=0;
	}
	undoList.pop_back();
}
static char undobuf[256];
strcpy(undobuf,"Undo ");
strcat(undobuf,undo_type());
//if(undoMenuItem) undoMenuItem->label(undobuf);
}

void undo() {
  if(undoList.size()<1) return;
int i;

UndoRedo ur=undoList.back();
switch(ur.type) {
case UR_SELECTION:
	break;
case UR_CHANGE:
	trigger[ur.triggerId]=*ur.trigger;
	break;
case UR_DELETE:
	for(i=triggerList->size();i>=ur.triggerId;i--) {
		trigger[i+1]=trigger[i];
	}
	trigger[ur.triggerId]=*ur.trigger;
	triggerList->insert(ur.triggerId,"Undo");
	break;
case UR_ADD:
	triggerList->remove(ur.triggerId);
	for(i=ur.triggerId;i<triggerList->size()+1;i++) {
		trigger[i]=trigger[i+1];
	}
	break;
case UR_STEPANDREPEAT:
	for(i=0;i<ur.triggerIdCount;i++) {
		triggerList->remove(ur.triggerId);
	}
	break;
}
activeTrigger=ur.triggerId;
triggerList->select(activeTrigger);
update_trigger();
activeStage=ur.stageId;
triggerStage->value(activeStage);
update_stage();

undoList.pop_back();

static char undobuf[256];
strcpy(undobuf,"Undo ");
strcat(undobuf,undo_type());
undoMenuItem->label(undobuf);
}

const char * undo_type() {
  if(undoList.size()==0) return "Empty";
switch(undoList.back().type) {
case UR_SELECTION: return "Selection";
case UR_CHANGE: return "Trigger Change";
case UR_ADD: return "New Trigger";
case UR_DELETE: return "Delete Trigger";
case UR_STEPANDREPEAT: return "Step and Repeat";
}
return "Unknown";
}
